 '===================================================='
 ' objective is to create a wrapper on an Arduino library for B4R
 ' 2 way:
 '   - a wrapper without code added in wrapper
 '   - a wrapper with code added to take in account an event (like data available)
 '====================================================='
 option explicit
 const module_name  = "B4R_library"           'this name must be unique !!!
 const module_desc  = "B4R library creation"  'script description
 const module_ver   = "0.003"                 'version  du 25/07/2020

 public mychaine, myarray, myfilename, fi, fj 
 public obj1, obj2, s ,linemax , wshshell, btncode                 'variable definition
 public svpara,svpar1, svpar2, l_max2, l_max, B4Rname                  
 public myinitB, myinitP, myinitincludeB, myinitincludeP, myloopI, myloopB, myloopP, myloopConf1, myeventB1, myeventP1, myloopConf2, myeventB2, myeventP2, myloopConf3, myeventB3, myeventP3, mycbkB1, mycbkP1, mycbkConf1, mycbkB2, mycbkP2, mycbkConf2, mycbkB3, mycbkP3, mycbkConf3, mybackend
 public private0, private1, private2, private3
 '===============================================' 
 'not used
 '===============================================' 
 sub Main 
 end sub



            
  
 '===============================================' 
 'B4Rlibrary  Phase 0
 ' clean of xxx.h from arduino  and create xxx.h.clean file
 ' GLOBAL script
 '===============================================' 
 sub clean 
   logclear                        'main procedure  creation of a B4X.cpp file from h file arduino 
   set obj1 = NewEditor()           'new editor object
   set obj2 = NewEditor()           'new editor object       
   obj1.assignActiveEditor         'assign PSPad window active to obj1
   myfilename =  obj1.filename

   fi = instrrev(myfilename,".")
   fj = instrrev(myfilename,"\")
   obj2.NewFile(left(myfilename,fj) + mid(myfilename,fj+1) + ".clean" )
   myfilename = mid(myfilename,fj+1,fi-fj-1)
''   logaddline(myfilename)
   B4Rname = "B4R"+ myfilename
   logaddline("B4Rname="+B4Rname)   
  
   Dim i,j, flag_class,flag_comment,flag_public,flag_tag, l_max ,l_p1 ,myline
   mychaine = obj1.text
   mychaine = replace(mychaine,chr(13),"")
   mychaine = replace(mychaine,chr(09),"    ")
   mychaine = replace(mychaine,"{",chr(10)+"{"+chr(10))
   mychaine = replace(mychaine,"}",chr(10)+"}"+chr(10))
   myarray = split(mychaine,chr(10))
   l_max = ubound(myarray)
   
   flag_comment = 0 :flag_class = 0 :flag_public = 1 :flag_tag = 0  : mychaine = ""
   for j = 0 to l_max
      logaddline(j)
      myline = trim(myarray(j))
      l_p1 =  instr(myarray(j),"//") 
      if myline = ""  then 
           myarray(j) = ""          
      elseif left(myline,2) = "//" then 
           myarray(j) = ""  
'suppression des commentaires'  
      elseif l_p1 > 1 then 
           myarray(j) = mid(myarray(j),1,l_p1-1)  
      end if     
'suppression des lignes de commentaires entre /** et */'     
      if left(myline,2) = "/*" then
         if instr(myline,"*/") > 0 then 
            myarray(j) = ""
         else
           flag_comment = 1 
         end if  
      end if    
      if instr(myline,"*/") > 0 then
         flag_comment = 0  
         myarray(j) = "" 
      end if
      if (flag_comment = 1)  then myarray(j) = "" 
      
      myline = trim(myarray(j))     'new line without comments'
      if left(myline,6) = "class " then
         flag_class = 1
         flag_tag = 0
         logaddline("==>class")
      elseif left(myline,7) = "public:" then
         flag_public = 1                     
         logaddline("==>public")
      elseif left(myline,10) ="protected:" then 
'//         myarray(j) = ""
         flag_public = 0                                
      elseif left(myline,8) ="private:" then
         logaddline("==>private")
'//         myarray(j) = ""
         flag_public = 0  
      end if
     
      if instr(myarray(j),"{") > 0 then  flag_tag = flag_tag +1         
     'suppression des lignes non class public' 
      if  not(flag_public= 1 and flag_class = 1)  then myarray(j) = ""                  
''      logaddline( flag_class)
      if instr(myline,"}") > 0 and flag_class = 1 then
''          logaddline("flag_tag")
         if flag_tag > 0 then flag_tag = flag_tag -1   
         if flag_tag = 0  then 
             flag_class = 0
             logaddline("end flag_class")
             flag_public = 0
             myarray(j)= "}"
         end if     
      end if                                                    
   next     
   flag_class = 0 

'header to select wrapper configuration    
   mychaine =             "    //#New(backend):                                                 //- [Y]  if new (backend) to add"+ chr(10) 
   mychaine =  mychaine + "    //#Init_Base:                                                    //- parameter to add at launch of library in case of backend" + chr(10) 
   mychaine =  mychaine + "    //#Init_Include:                                                 //- function added at initialization (it can be Loop_Base)" + chr(10)  
   mychaine =  mychaine + "    //#Loop_Base:                                                    //- function launched at loop start and activation callback function on event" + chr(10)  
   mychaine =  mychaine + "    //#Loop1_Event:                                                  //- event to monitor in a loop" + chr(10)    
   mychaine =  mychaine + "    //#Loop1_Config: SubVoid_Void  0 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub" + chr(10)
   mychaine =  mychaine + "    //#Loop2_Event:                                                  //- event to monitor in a loop" + chr(10)    
   mychaine =  mychaine + "    //#Loop2_Config: SubVoid_Void  0 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub" + chr(10)
   mychaine =  mychaine + "    //#Loop3_Event:                                                  //- event to monitor in a loop" + chr(10)    
   mychaine =  mychaine + "    //#Loop3_Config: SubVoid_Void  0 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub" + chr(10)     
   mychaine =  mychaine + "    //#CallBack1_Base:                                               //- callback on arduino side" + chr(10)      
   mychaine =  mychaine + "    //#CallBack1_Config: SubVoid_BArray 0 MessageArrivedSub          //- CallbackType Par1 EndPar callbacksub" + chr(10)          
   mychaine =  mychaine + "    //#CallBack2_Base:                                               //- callback on arduino side" + chr(10)         
   mychaine =  mychaine + "    //#CallBack2_Config: SubVoid_StringBArray 0 2 NewMessageSub      //- CallbackType Par1 Par2 EndPar callbacksub" + chr(10)      
   mychaine =  mychaine + "    //#CallBack3_Base:                                               //- callback on arduino side" + chr(10)         
   mychaine =  mychaine + "    //#CallBack3_Config: SubVoid_StringBArray 0 2 NewMessageSub      //- CallbackType Par1 Par2 EndPar callbacksub" + chr(10)     
   mychaine =  mychaine + "    //#" + chr(10) 
     
   for i = 0 to l_max
     if trim(myarray(i)) <> "" then
          mychaine = mychaine +chr(10) + myarray(i) 
     end if
   next 
   mychaine = replace(mychaine,"*"," * ")
   mychaine = replace(mychaine,"  *"," *")
   mychaine = replace(mychaine,"  *"," *")
   mychaine = replace(mychaine,"*  ","* ")
   mychaine = replace(mychaine,"*  ","* ")
   mychaine = replace(mychaine,chr(13),"")
   
   obj2.text (mychaine)       
         
   logAddLine("end file.h.clean creation")
   sleep(100)      
''    logaddline("fin du clean du fichier")
 end sub




 
  '==============================================' 
  ' B4Rlibrary Phase 1
  ' creation of xxx.cpp file for B4R from xxx.h.clean arduino
  ' Global case'
  '==============================================' 
sub cpp_create  
   Dim i,j,myclass ,myclass2 ,myline ,l_p1 ,l_p2 ,svline ,svcmd ,svcmd2 ,linetype ,linetypeAV ,myevent ,myinit, mystream, allcmd

   set obj1 = NewEditor()           'new editor object
   set obj2 = NewEditor()           'new editor object       
   obj1.assignActiveEditor         'assign PSPad window active to obj1
   myfilename =  obj1.filename
   logclear
   fi = instr(myfilename,".")
   fj = instrrev(myfilename,"\")
   obj2.NewFile(left(myfilename,fj) + "r" + mid(myfilename,fj+1,fi-fj) + "cpp" )
   myfilename = mid(myfilename,fj+1,fi-fj-1)
''   logaddline(myfilename)
   
   B4Rname = "B4R"+ myfilename
   logaddline("B4Rname="+B4Rname)   
   mychaine = obj1.text
        
   cpp_replace     'global changes done on all file'
   mod_cleanfile   ' changes done only on this library from lines at end of xxx.h.clean file'
   
   mychaine = replace(mychaine,chr(13),"")
   mychaine = replace(mychaine,chr(09),"    ")
   myarray = split(mychaine,chr(10))
   l_max = ubound(myarray)   
'' logaddline(l_max)

   myline = trim(myarray(0))
   if left(myline,16)= "//#New(backend):" then
         mybackend = trim(mid(myline,17,instr(myline,"//-")-17))  
         if (mybackend = "")or(mybackend <> "Y") then mybackend = "N"
   end if
       
   if mybackend = "N" then       
      cpp1_create    'simple cpp file without new(backend)'
   else
      cpp2_create    'complex case with new(backend) , code added, loop, detection of data available
   end if  

end sub


  '==============================================' 
  ' B4Rlibrary Phase 1
  ' [cpp creation] for B4R from xxx.h.clean arduino
  ' simple  case without NEW(BACKEND)'
  '==============================================' 
sub cpp1_create 
   Dim i,j,myclass ,myclass2 ,myline ,l_p1 ,l_p2,l_p3, svline ,svcmd ,svcmd2 ,linetype ,linetypeAV
   dim myevent ,myinit, mystream, allcmd, myenum,myenum1,myenum2, mychaine2 , mystruct, flag_code

   mychaine = ""     
   for i = 0 to 17
     mychaine = mychaine +myarray(i) + chr(10)
     myarray(i) = "" 
   next   
   
   myclass = ""
   mychaine = mychaine + "#include "+chr(34)+"B4RDefines.h"+chr(34) + chr(10)
   mychaine = mychaine + "#include "+chr(34)+"r"+ myfilename +".h"+chr(34)+chr(10)+chr(10)         
   mychaine = mychaine +"namespace B4R"+chr(10)  + "{" + chr(10)
   
   allcmd = "" : myenum = "0" : mychaine2 = "" 
   for j = 0 to l_max
      myline = trim(myarray(j))
      flag_code = ""
      logaddline(j)
      linetype = ""
      if myline = "" then
         myarray(j) = ""     
      elseif left(myline,2) = "//" or myline ="{" or myline = "}" then                        ' case line comment to ignore'
''         mychaine = mychaine + myarray(j) +chr(10)
         myarray(j) = ""  
''         logaddline(myline) 
      elseif left(myline,5) = "class" then                'case class'
         myline = trim(mid(myline,6))
''         flagclass = 1
         l_p1 = instr(myline," ") 
         if l_p1 > 0 then 
            myclass = left(myline,l_p1-1)
         else  
            myclass =left(myline,len(myline))
         end if  
         myclass2 = lcase(myclass)
''       logaddline("-myclass "+myclass) 
         mychaine = mychaine + chr(10) +"    "+myclass+" "+myclass2+";"+chr(10)  
         B4Rname = "B4R"+myclass
         myarray(j)=""     
      elseif left(myline,7) = "public:" then             'case public:'
         myarray(j) = ""
 ''        flagpublic = 1
         mychaine = mychaine + chr(10)  
      elseif left(myline,1)= "~"  then                   'case ~'
         myarray(j) = ""
         mychaine = mychaine + chr(10) 
      elseif mid(myline,1,instr(myline,"(")-1) = myclass then
         myarray(j) = ""
''         logaddline("myclass suppirm"+myclass)
'-----------------------------------------            
      elseif left(myline,6)= "struct"  then   
         mystruct = 1                'case struct~'
         mychaine = mychaine + "//"+myarray(j) + chr(10) 
      elseif mystruct = 1  then                                          'case struct~'
         mychaine = mychaine + "//"+myarray(j) + chr(10) 
         myarray(j) = "" 
         if left(myline,1)= "}"  then                 'end struct'
            mystruct = 0  
''            myarray(j) = ""
         end if   
'-----------------------------------------        
      else   
         linetype = sortreturn(myline,1)                   'adaptation return parameter to type known by B4X'
         l_p1 = instr(linetype,"|")
         linetypeAV = mid(linetype,l_p1+1)
         linetype = mid(linetype,1,l_p1-1)
 ''       logaddline(myline)
         if linetype <> ""  then
            l_p1 = instr(myline,"(")
            l_p2 = instrrev(myline,")")
            l_p3 = instr(myline,"=")
''          logaddline(l_p1)
''          logaddline(l_p2)          
''          logaddline(l_p3)
            if l_p1 <1 and l_p2 <1 and l_p3> 0 then     'case simple data  : type name = value   
''               logaddline(myline)
               l_p2 = instr(myline, " ")
               svcmd = left(myline,l_p2-1)
               myline = "//enum           #define /*"+linetype+" " +ucase(svcmd)+";*/ " + "B4R"+ myclass+"_"+ucase(svcmd)  + " "+ myclass +"::" +svcmd                 
               mychaine = mychaine + myline +chr(10) 
               myarray(j) = ""    
            elseif l_p1 <1 and l_p2 <1 and l_p3 <1 then     'case simple data  : type name    
''               logaddline(myline)
               l_p2 = instr(myline, " ")
               svcmd =myline
               myline = "//enum           #define /*"+linetype+" " +ucase(svcmd)+";*/ " + "B4R"+ myclass+"_"+ucase(svcmd)  + " "+ myclass +"::" +svcmd                 
               mychaine = mychaine + myline +chr(10) 
               myarray(j) = ""                        
            elseif l_p1 >0 and l_p2 >0 and l_p2>l_p1 then    'case function or procedure'     
               myarray(j)= ""       
               svcmd = left(myline,l_p1-1)
               svcmd2=cpp_rename_dup(svcmd,allcmd)       'rename of duplicated commands'
               allcmd = allcmd +svcmd2+"-"+chr(10)   
               
''               logaddline(svcmd)
               svpara = mid(myline,l_p1+1,l_p2-l_P1-1)   
               call sortpara                        

               myline = "    "+linetype+" "+ B4Rname +"::"+ svcmd2 +"(" 
               if l_max2 <> -1 then
                  for i = 0 to l_max2
                    if i <> 0 then  myline = myline + ", "
                     myline = myline + svpar1(i)
                  next      
               end if 
               myline = myline + ")"  + chr(10)
               myline = myline + "    {" + chr(10)  
               if linetype <> "void" then
                  myline = myline + "       return "+ myclass2+"." + svcmd + "("
               else
                  myline = myline + "       "+  myclass2+"."+ svcmd + "(" 
               end if     
               if l_max2 <> -1 then
                  for i = 0 to l_max2
                     if i <> 0 then myline = myline +", "
                     myline = myline + svpar2(i)              
                  next      
               end if
               myline = myline + ");"  + chr(10)
               myline = myline + "    }" + chr(10)  +chr(10)
               mychaine = mychaine + myline 
               flag_code = "1"
                     
            end if 
            'case { code } code added 
            if flag_code = "1" and j <> ubound(myarray) then 
               if left(trim(myarray(j+1)),1) = "{" then 
''                              logaddline(myarray(j+1))
                  myarray(j+1)= "" ' // "+ myarray(j+1)
                  if left(trim(myarray(j+2)),1) = "}" then 
                      myarray(j+2)= "" '// "+ myarray(j+2)  
                  else
''                                 logaddline(myarray(j+3))
                      myarray(j+2)= "" '' "// "+ myarray(j+2)  
                      myarray(j+3)= "" '// "+ myarray(j+3)  
                  end if                                                              
               end if
               flag_code = ""
            end if   
         end if 
         
         if left(myline,5) = "enum "  then                    'case ENUM'              enum = 1       enum = 0       enum = 0 not enum
            myenum = "1" ': myenum1 = "B4RV"+ucase(trim(+mid(myline,6))) 
            if instr(myline,":")> 0 then 
               myenum1 = "B4RV"+ucase(trim(+mid(myline,6,instr(myline,":")-6)))          
               myenum2 =  trim(mid(myline,instr(myline,":")+1) )
           else
               myenum1 = "B4RV"+ucase(trim(+mid(myline,6))) 
               myenum2 =  "?????"
               logaddline (" enum without type of variable =>part missing like [:byte]")
            end if   
            myline = "//enum    //~shortname:"+ mid(myenum1,5) + chr(10)  
''            myline = "//enum     };"+chr(10)+"//enum    //~shortname:"+ mid(myenum1,5) + chr(10)              
            myline = myline +"//enum     class "+ myenum1 +chr(10) +"//enum     {"+chr(10)+"//enum        public:" 
            mychaine2 = mychaine2 + myline +chr(10)
            myarray(j)=""
''          logaddline("myenum0="+myenum)
         elseif myenum = "1" then 
''            logaddline("myenum1="+myenum)
            if left(myline,1) = "{" then
               myenum = "2"
               myarray(j)=""
   
            elseif left(myline,1) = "}" then
               myenum = "0"
               myarray(j)=""
            end if
         elseif myenum = "2"  then
            if left(myline,1) = "}" then 
               myenum = "0"
               mychaine2 = mychaine2 +"//enum     }"+chr(10)
               myarray(j)=""
''             logaddline("myenum2="+myenum)
            else
               if instr(myline,"=")> 0 then
                 myline = "//enum           #define /*"+myenum2+" " +ucase(trim(left(myline,instr(myline,"=")-1)))+";*/ " + myenum1 +"_" + ucase(trim(left(myline,instr(myline,"=")-1)))  + " "+ myclass+"::" +trim(left(myline,instr(myline,"=")-1))                 
               else
                 myline = "//enum           #define /*"+myenum2+" "+ ucase(trim(left(myline,instr(myline," "))))+";*/ " +myenum1 +"_" + ucase(trim(left(myline,instr(myline," "))))  + " "+ myclass+"::" +trim(left(myline,instr(myline," ")))
               end if
               mychaine2 = mychaine2 + myline +chr(10) 
               myarray(j) = ""
''             logaddline("myenum="+myenum)
            end if
         elseif left(myline,1) = "}" then
            myarray(j)=""
         end if    

         if trim(myarray(j)) <> "" then 
            mychaine = mychaine + "//?? "+ myarray(j) +chr(10)
            myarray(j) = ""
         end if  
      end if       
   next
   mychaine = mychaine + "}" + chr(10)
   mychaine = mychaine +mychaine2
   mychaine = replace(mychaine,chr(13),"")
   obj2.text (mychaine)       
         
   logAddLine("end file.cpp creation")
   sleep(100)      
end sub     




  
  '==============================================' 
  ' B4Rlibrary Phase 1
  ' [cpp creation] for B4R from file.h.clean arduino
  ' case with NEW(BACKEND)'
  '==============================================' 
sub cpp2_create 
   Dim i,j,myclass ,myclass2 ,myline ,l_p1 ,l_p2 , l_p3, svline ,svcmd ,svcmd2 ,linetype ,linetypeAV
   dim myenum,myenum1,myenum2, mychaine2, mystruct,allcmd, flag_code, plus_flag
   dim  mytemp, mytemp_max, mytmp, mytmp1, mytmp2, mytmp3, stack_flag
    myclass=""
    if confinit = false then exit sub

   mychaine = ""     
   for i = 0 to 17
     mychaine = mychaine +myarray(i) + chr(10)
     myarray(i) = "" 
   next   
   mychaine = mychaine + "#include "+chr(34)+"B4RDefines.h"+chr(34) + chr(10) + chr(10)      
   mychaine = mychaine +"namespace B4R"+chr(10)  + "{" + chr(10) 
       
   allcmd = ""  :plus_flag =0
   for j = 0 to l_max
     myline = trim(myarray(j))
     flag_code = ""
     logaddline(j)
     linetype = ""
''   logaddline(myline)
     if left(myline,2) = "//" then                        ' case line comment to ignore'
       mychaine = mychaine + myarray(j) +chr(10)
       myarray(j) = ""   
         
     elseif left(myline,5) = "class" then                'case class'
       myline = trim(mid(myline,6))
       l_p1 = instr(myline," ") 
       if l_p1 > 0 then 
         myclass = left(myline,l_p1-1)
       else  
          myclass =left(myline,len(myline))
       end if  
       myclass2 = lcase(myclass)

       B4Rname = "B4R"+myclass
       myarray(j)=""  
       mychaine = mychaine + chr(10) 
         
       if mycbkB1 <> "" then mychaine = mychaine +"    "+ B4Rname+"* "+B4Rname+"::instance = NULL;"+chr(10)  
             
       mychaine = mychaine +"    void "+B4Rname+"::Initialize("
       if myinitP <> "" then 
          mychaine = mychaine + adaptpara(myinitP,1)  : plus_flag = 1
       end if 
 
'****** case loop in initialize part *******'  
       if myloopI = "Y" then          
          if myinitincludeP <> "" and myinitincludeP <> "void" then                              ' case loop'
            if  plus_flag= 1 then   mychaine = mychaine +", "           
            mychaine = mychaine + adaptpara(myinitincludeP,1)  : plus_flag = 1
          end if          
'//          if myloopP<>"" and myloopP<>"void" then                              ' case loop'
'//            if  plus_flag= 1 then   mychaine = mychaine +", "           
'//            mychaine = mychaine + adaptpara(myloopP,1)  : plus_flag = 1
'//          end if            
          mytemp = wordsplit(myloopConf1) : mytemp_max = ubound(mytemp)            'case event1
          if  plus_flag= 1 then   mychaine = mychaine +", "
          mychaine = mychaine + mytemp(0) + " " + mytemp(mytemp_max)  : plus_flag = 1
          if myeventB2<>"" then 
             mytemp = wordsplit(myloopConf2) : mytemp_max = ubound(mytemp)            'case event2
             mychaine = mychaine +", "+ mytemp(0) + " " + mytemp(mytemp_max)  : plus_flag = 1
          end if 
          if myeventB3<>"" then 
             mytemp = wordsplit(myloopConf3) : mytemp_max = ubound(mytemp)            'case event3
             mychaine = mychaine +", "+ mytemp(0) + " " + mytemp(mytemp_max)  : plus_flag = 1
          end if                    

          if mycbkB1 <> "" then 
             mytemp = wordsplit(mycbkConf1) : mytemp_max = ubound(mytemp)            'backcall1 config
             if  plus_flag= 1 then   mychaine = mychaine +", "
             mychaine = mychaine + mytemp(0) + " " + mytemp(mytemp_max)  : plus_flag = 1
          end if   
          if mycbkB2 <> "" then          
             mytemp = wordsplit(mycbkConf2) : mytemp_max = ubound(mytemp)            'backcall1 config
             mychaine = mychaine + ", "+mytemp(0) + " " + mytemp(mytemp_max) : plus_flag = 1                        
          end if   
          if mycbkB3 <> "" then          
             mytemp = wordsplit(mycbkConf3) : mytemp_max = ubound(mytemp)            'backcall1 config
             mychaine = mychaine + ", "+mytemp(0) + " " + mytemp(mytemp_max) : plus_flag = 1                        
          end if  
          mychaine = mychaine+      ")"+chr(10)  
          plus_flag = 0
        
          mychaine = mychaine +"    {" + chr(10)
          mychaine = mychaine +"       rcs = new (backend) "+myclass+ "(" 
          mychaine = mychaine + adaptpara(myinitP,2)                                                     
          mychaine = mychaine +");" + chr(10)
       
          if myeventB1 <> "" and myloopI = "Y" then                                                      'external loop 1'
             mytemp = wordsplit(myloopConf1) : mytemp_max = ubound(mytemp) 
             mychaine = mychaine +"       this->"+mytemp(mytemp_max)+" = "+mytemp(mytemp_max)+"; " + chr(10)
          end if
          if myeventB2 <> "" and myloopI = "Y" then                                                      'external loop 2'
             mytemp = wordsplit(myloopConf2) : mytemp_max = ubound(mytemp) 
             mychaine = mychaine +"       this->"+mytemp(mytemp_max)+" = "+mytemp(mytemp_max)+"; " + chr(10)
          end if       
          if myeventB3 <> "" and myloopI = "Y" then                                                      'external loop 3'
             mytemp = wordsplit(myloopConf3) : mytemp_max = ubound(mytemp) 
             mychaine = mychaine +"       this->"+mytemp(mytemp_max)+" = "+mytemp(mytemp_max)+"; " + chr(10)
          end if 
              
          if mycbkB1 <> "" then
             mytemp = wordsplit(mycbkConf1) : mytemp_max = ubound(mytemp)          
''           logaddline("=>||"+mycbkConf1+"||"+mytemp(mytemp_max)+"||")
             mychaine = mychaine +"       this->"+mytemp(mytemp_max)+" = "+mytemp(mytemp_max)+"; " + chr(10)
          end if
          if mycbkB2 <> "" then
             mytemp = wordsplit(mycbkConf2) : mytemp_max = ubound(mytemp)   
''           logaddline("=>||"+mycbkConf2+"||"+mytemp(mytemp_max)+"||")
             mychaine = mychaine +"       this->"+mytemp(mytemp_max)+" = "+mytemp(mytemp_max)+"; " + chr(10)
          end if
          if mycbkB3 <> "" then
             mytemp = wordsplit(mycbkConf3) : mytemp_max = ubound(mytemp)   
''           logaddline("=>||"+mycbkConf3+"||"+mytemp(mytemp_max)+"||")
             mychaine = mychaine +"       this->"+mytemp(mytemp_max)+" = "+mytemp(mytemp_max)+"; " + chr(10)
          end if 
          if mycbkB1 <> "" then mychaine = mychaine +"       instance = this;"+chr(10)         'added for callback fiunction
                            
          mychaine = mychaine +"       FunctionUnion fu; "+ chr(10)               
	      mychaine = mychaine +"       fu.PollerFunction = looper;"+ chr(10)
          mychaine = mychaine +"       pnode.functionUnion = fu;"+ chr(10)
	      mychaine = mychaine +"       pnode.tag = this; "+ chr(10)
	      mychaine = mychaine +"       if (pnode.next == NULL) "+ chr(10)
	      mychaine = mychaine +"          pollers.add(&pnode); "+ chr(10)
          if myloopB <> "" then
          mytemp = mid(myloopB,instr(myloopB," ")+1)          
             mychaine = mychaine +"       rcs->"+mytemp+"("+adaptpara(myloopP,2)
             mychaine = mychaine +");"+ chr(10)  
          end if  
          if (myinitincludeB <> "")  and (myloopB <> myinitincludeB) then
             mytemp = mid(myinitincludeB,instr(myinitincludeB," ")+1) 
             mychaine = mychaine +"       rcs->"+mytemp+"("+adaptpara(myinitincludeP,2) 
''             mychaine = mychaine +");"+ chr(10)  
             mychaine = mychaine +");"+ chr(10) 
          end if          
          mychaine = mychaine +"    };"+ chr(10)+chr(10)         'end initialization function'

''        if  myloopI = "Y"  then                                                            'loop function in a new functionl
       '  loop function added'
          mychaine = mychaine +"    void "+B4Rname+"::looper(void* b) " + chr(10)         'loop function added'
          mychaine = mychaine +"    {" + chr(10)
          mychaine = mychaine +"       "+B4Rname+"* me = ("+B4Rname+"*)b;" +chr(10)
         'myeventB1'
          mytemp = makeloop(myeventB1,myeventP1,myloopConf1)
                  
          if myeventB2 <> ""then
             mytemp = makeloop(myeventB2,myeventP2,myloopConf2)
          end if  
          
          if myeventB3 <> ""then
             mytemp = makeloop(myeventB3,myeventP3,myloopConf3)
          end if
            
          mychaine = mychaine +"    };" + chr(10)   
          private0 = B4Rname+"::looper("

       else 
'//          if myloopP <> "" and myloopP <> "void" then                              ' case loop'
'//            if  plus_flag= 1 then   mychaine = mychaine +", "           
'//            mychaine = mychaine + adaptpara(myloopP,1)  : plus_flag = 1
'//          end if              
          if mycbkB1 <> "" then 
             mytemp = wordsplit(mycbkConf1) : mytemp_max = ubound(mytemp)            'backcall1 config
             if  plus_flag= 1 then   mychaine = mychaine +", "
             mychaine = mychaine + mytemp(0) + " " + mytemp(mytemp_max)  : plus_flag = 1
          end if   
          if mycbkB2 <> "" then      
             mytemp = wordsplit(mycbkConf2) : mytemp_max = ubound(mytemp)            'backcall1 config
             mychaine = mychaine + ", "+mytemp(0) + " " + mytemp(mytemp_max) : plus_flag = 1                        
          end if   
          if mycbkB3 <> "" then        
             mytemp = wordsplit(mycbkConf3) : mytemp_max = ubound(mytemp)            'backcall1 config
             mychaine = mychaine + ", "+mytemp(0) + " " + mytemp(mytemp_max) : plus_flag = 1                        
          end if  
          mychaine = mychaine+      ")"+chr(10)  
          plus_flag = 0
        
          mychaine = mychaine +"    {" + chr(10)
          mychaine = mychaine +"       rcs = new (backend) "+myclass+ "(" 
          mychaine = mychaine + adaptpara(myinitP,2)                                                     
          mychaine = mychaine +");" + chr(10)       
              
          if mycbkB1 <> "" then
             mytemp = wordsplit(mycbkConf1) : mytemp_max = ubound(mytemp)          
''           logaddline("=>||"+mycbkConf1+"||"+mytemp(mytemp_max)+"||")
             mychaine = mychaine +"       this->"+mytemp(mytemp_max)+" = "+mytemp(mytemp_max)+"; " + chr(10)
          end if
          if mycbkB2 <> "" then
             mytemp = wordsplit(mycbkConf2) : mytemp_max = ubound(mytemp)   
''           logaddline("=>||"+mycbkConf2+"||"+mytemp(mytemp_max)+"||")
             mychaine = mychaine +"       this->"+mytemp(mytemp_max)+" = "+mytemp(mytemp_max)+"; " + chr(10)
          end if
          if mycbkB3 <> "" then
             mytemp = wordsplit(mycbkConf3) : mytemp_max = ubound(mytemp)   
''           logaddline("=>||"+mycbkConf3+"||"+mytemp(mytemp_max)+"||")
             mychaine = mychaine +"       this->"+mytemp(mytemp_max)+" = "+mytemp(mytemp_max)+"; " + chr(10)
          end if 
          if mycbkB1 <> "" then mychaine = mychaine +"       instance = this;"+chr(10)         'added for callback fiunction
          if (myinitincludeB <> "")  and (myloopB <> myinitincludeB) then
             mytemp = mid(myinitincludeB,instr(myinitincludeB," ")+1) 
             mychaine = mychaine +"       rcs->"+mytemp+"("+adaptpara(myinitincludeP,2) 
''             mychaine = mychaine +");"+ chr(10)  
             mychaine = mychaine +");"+ chr(10) 
          end if          
          mychaine = mychaine +"    };"+ chr(10)+chr(10)         'end initialization function' 
 
         'add function at start of loop only if a loop is needed'
          if myloopB<>"" then
             mytemp = mid(myloopB,1,instr(myloopB," ")-1)
             mychaine = mychaine +"    "+mytemp+" "+B4Rname+"::"
             mytemp = mid(myloopB,instr(myloopB," ")+1)
             mychaine = mychaine +mytemp+"("+adaptpara(myloopP,1)  

          if  adaptpara(myloopP,1) <>"" then   mychaine = mychaine +", "   
             mytemp = wordsplit(myloopConf1) : mytemp_max = ubound(mytemp)            'case event1
             mychaine = mychaine + mytemp(0) + " " + mytemp(mytemp_max)  
          if myeventB2<>"" then 
             mytemp = wordsplit(myloopConf2) : mytemp_max = ubound(mytemp)            'case event2
             mychaine = mychaine +", "+ mytemp(0) + " " + mytemp(mytemp_max)  
          end if  
          if myeventB3<>"" then 
             mytemp = wordsplit(myloopConf3) : mytemp_max = ubound(mytemp)            'case event2
             mychaine = mychaine +", "+ mytemp(0) + " " + mytemp(mytemp_max)  
          end if           
          mychaine = mychaine +") " + chr(10)

          mychaine = mychaine +"    {" + chr(10)  
          if myeventB1 <> "" then                                                      'external loop 1'
             mytemp = wordsplit(myloopConf1) : mytemp_max = ubound(mytemp) 
             mychaine = mychaine +"       this->"+mytemp(mytemp_max)+" = "+mytemp(mytemp_max)+"; " + chr(10)
          end if
          if myeventB2 <> "" then                                                      'external loop 2'
             mytemp = wordsplit(myloopConf2) : mytemp_max = ubound(mytemp) 
             mychaine = mychaine +"       this->"+mytemp(mytemp_max)+" = "+mytemp(mytemp_max)+"; " + chr(10)
          end if       
          if myeventB3 <> "" then                                                      'external loop 3'
             mytemp = wordsplit(myloopConf3) : mytemp_max = ubound(mytemp) 
             mychaine = mychaine +"       this->"+mytemp(mytemp_max)+" = "+mytemp(mytemp_max)+"; " + chr(10)
          end if                   
          mychaine = mychaine +"       FunctionUnion fu; "+ chr(10)               
	      mychaine = mychaine +"       fu.PollerFunction = looper;"+ chr(10)
          mychaine = mychaine +"       pnode.functionUnion = fu;"+ chr(10)
	      mychaine = mychaine +"       pnode.tag = this; "+ chr(10)
	      mychaine = mychaine +"       if (pnode.next == NULL) "+ chr(10)
	      mychaine = mychaine +"          pollers.add(&pnode); "+ chr(10)
          if myloopB <> "" then
          mytemp = mid(myloopB,instr(myloopB," ")+1)          
             mychaine = mychaine +"       rcs->"+mytemp+"("+adaptpara(myloopP,2) 
             mychaine = mychaine +");"+ chr(10)  
          end if  
        
          mychaine = mychaine +"    };"+ chr(10)+chr(10)         'end initialization function' 
          
         'loop function in a new functionl
          mychaine = mychaine +"    void "+B4Rname+"::looper(void* b) " + chr(10)         'loop function added'
          mychaine = mychaine +"    {" + chr(10)
          mychaine = mychaine +"       "+B4Rname+"* me = ("+B4Rname+"*)b;" +chr(10)

         'myeventB1'
          mytemp = makeloop(myeventB1,myeventP1,myloopConf1)                  
          if myeventB2 <> ""then
             mytemp = makeloop(myeventB2,myeventP2,myloopConf2)
          end if            
          if myeventB3 <> ""then
             mytemp = makeloop(myeventB3,myeventP3,myloopConf3)
          end if
             mychaine = mychaine +"    };" + chr(10)  +chr(10) 
          private0 = B4Rname+"::looper("
       end if
       end if  
      'now we have to add callback functions at end of cpp file'
       if mycbkB1 <> "" then       'loop start in a specific function '
          mytemp = makecbk(mycbkB1,mycbkP1,mycbkConf1)
       end if       
       if mycbkB2 <> "" then       'callback in a specific function '
          mytemp = makecbk(mycbkB2,mycbkP2,mycbkConf2)
       end if  
       if mycbkB3 <> "" then       'callback in a specific function '
          mytemp = makecbk(mycbkB3,mycbkP3,mycbkConf3) 
       end if               

    
    

       
     elseif left(myline,7) = "public:" then             'case public:'
        myarray(j) = ""
        mychaine = mychaine + chr(10)  
     elseif left(myline,1)= "~"  then                   'case ~'
        myarray(j) = ""
        mychaine = mychaine + chr(10) 
'-----------------------------------------            
     elseif left(myline,6)= "struct"  then   
        mystruct = 1                'case struct~'
        mychaine = mychaine + "//"+myarray(j) + chr(10) 
     elseif mystruct = 1  then                                          'case struct~'
        mychaine = mychaine + "//"+myarray(j) + chr(10) 
        myarray(j) = "" 
        if left(myline,1)= "}"  then                 'end struct'
           mystruct = 0  
''           myarray(j) = ""
        end if   
'-----------------------------------------            
     else 
        linetype = sortreturn(myline,2)
        l_p1 = instr(linetype,"|")
        linetypeAV = mid(linetype,l_p1+1)
        linetype = mid(linetype,1,l_p1-1)
''    logaddline(linetype)
''    logaddline(linetypeAV)                    
        if linetype <> ""  then
           l_p1 = instr(myline,"(")
           l_p2 = instrrev(myline,")")
''           logaddline(l_p1)
''           logaddline(l_p2) 
           l_p3 = instr(myline,"=")            
           if l_p1 <1 and l_p2 <1 and l_p3> 0 then     'case simple data  : type name = value   
''             logaddline(myline)
               l_p2 = instr(myline, " ")
               svcmd = left(myline,l_p2-1)
               myline = "//enum           #define /*"+linetype+" " +ucase(svcmd)+";*/ " + "B4R"+ myclass+"_"+ucase(svcmd)  + " "+ myclass +"::" +svcmd                 
               mychaine = mychaine + myline +chr(10) 
               myarray(j) = "" 
           elseif l_p1 <1 and l_p2 <1 and l_p3 <1 then     'case simple data  : type name    
''               logaddline(myline)
               l_p2 = instr(myline, " ")
               svcmd =myline
               myline = "//enum           #define /*"+linetype+" " +ucase(svcmd)+";*/ " + "B4R"+ myclass+"_"+ucase(svcmd)  + " "+ myclass +"::" +svcmd                 
               mychaine = mychaine + myline +chr(10) 
               myarray(j) = ""     
           elseif l_p1 >0 and l_p2 >0 and l_p2>l_p1 then         
              myarray(j)= ""
              svcmd = left(myline,l_p1-1)
              svcmd2=cpp_rename_dup(svcmd,allcmd)       'rename of duplicated commands'
              allcmd = allcmd +svcmd2+"-"+chr(10)   
               
''              logaddline(svcmd)
              svpara = mid(myline,l_p1+1,l_p2-l_P1-1)   
              call sortpara 
           
              'creation first line'           
              myline = "    "+linetype+" "+ B4Rname +"::"+ svcmd2 +"(" 
              if l_max2 <> -1 then
                 for i = 0 to l_max2
                   if i <> 0 then  myline = myline + ", "
                   myline = myline + svpar1(i)
                 next      
              end if 
              myline = myline + ")"  + chr(10)
              myline = myline + "    {" + chr(10)  
           
              'creation of content, depending of type of feature and type of return             
         
              if linetype = "void" then          'next lines case return=VOID'
                 myline = myline + "       "+ "rcs->"+ svcmd + "(" 
                 if l_max2 <> -1 then
                    for i = 0 to l_max2
                       if i <> 0 then myline = myline +", "
                       myline = myline + svpar2(i)              
                    next
                 end if      
                 myline = myline + ");"  + chr(10)
                 myline = myline + "    };" + chr(10)  +chr(10)
                 mychaine = mychaine + myline 
                 flag_code = "1" 
              
              elseif linetype= "ArrayByte*" then    'case array Byte'   
                 myline = myline + "       byte* raw = rcs->" + svcmd + "("    
                 if l_max2 <> -1 then
                    for i = 0 to l_max2
                       if i <> 0 then myline = myline +", "
                       myline = myline + svpar2(i)              
                    next      
                 end if
                 myline = myline + ");"  + chr(10)
                 myline = myline + "       uint16_t len = ??; //raw.size() or fixe value depending of the arduino part" +chr(10)
                 myline = myline + "       ArrayByte* arr = CreateStackMemoryObject(ArrayByte);" +chr(10)
                 myline = myline + "       arr->data=raw;"  +chr(10)
                 myline = myline + "       arr->length=len;"  +chr(10)
                 myline = myline + "       return arr;" +chr(10)              
                 myline = myline + "    };" + chr(10)  +chr(10)
                 mychaine = mychaine + myline 
                 flag_code = "1"   
              
              elseif linetype= "ArrayInt*" then    'case array Int'   
                 myline = myline + "       int16_t* raw = rcs->" + svcmd + "("    
                 if l_max2 <> -1 then
                    for i = 0 to l_max2
                        if i <> 0 then myline = myline +", "
                       myline = myline + svpar2(i)              
                    next      
                 end if
                 myline = myline + ");"  + chr(10)
                 myline = myline + "       uint16_t len = ??; //raw.size() or fixe value depending of the arduino part" +chr(10)
                 myline = myline + "       ArrayInt* arr = CreateStackMemoryObject(ArrayInt);" +chr(10)
                 myline = myline + "       arr->data=raw;"  +chr(10)
                 myline = myline + "       arr->length=len;"  +chr(10)
                 myline = myline + "       return arr;" +chr(10)              
                 myline = myline + "    };" + chr(10)  +chr(10)
                 mychaine = mychaine + myline  
                 flag_code = "1"  
              
              elseif linetype= "ArrayUInt*" then    'case array UInt'   
                 myline = myline + "       uint16_t* raw = rcs->" + svcmd + "("    
                 if l_max2 <> -1 then
                    for i = 0 to l_max2
                       if i <> 0 then myline = myline +", "
                       myline = myline + svpar2(i)              
                    next      
                 end if
                 myline = myline + ");"  + chr(10)            
                 myline = myline + "       uint16_t len = ??; //raw.size() or fixe value depending of the arduino part" +chr(10)
                 myline = myline + "       ArrayUInt* arr = CreateStackMemoryObject(ArrayUInt);" +chr(10)
                 myline = myline + "       arr->data=raw;"  +chr(10)
                 myline = myline + "       arr->length=len;"  +chr(10)
                 myline = myline + "       return arr;" +chr(10)              
                 myline = myline + "    };" + chr(10)  +chr(10)
                 mychaine = mychaine + myline 
                 flag_code = "1"   
              
              elseif linetype= "ArrayLong*" then    'case array Long'   
                 myline = myline + "       int32_t* raw = rcs->" + svcmd + "("    
                 if l_max2 <> -1 then
                    for i = 0 to l_max2
                       if i <> 0 then myline = myline +", "
                       myline = myline + svpar2(i)              
                    next      
                 end if
                 myline = myline + ");"  + chr(10)                 
                 myline = myline + "       uint16_t len = ??; //raw.size() or fixe value depending of the arduino part" +chr(10)
                 myline = myline + "       ArrayLong* arr = CreateStackMemoryObject(ArrayLong);" +chr(10)
                 myline = myline + "       arr->data=raw;"  +chr(10)
                 myline = myline + "       arr->length=len;"  +chr(10)
                 myline = myline + "       return arr;" +chr(10)              
                 myline = myline + "    };" + chr(10)  +chr(10)
                 mychaine = mychaine + myline
                 flag_code = "1"    
              
              elseif linetype= "ArrayULong*" then    'case array ULong'   
                 myline = myline + "       uint32_t* raw = rcs->" + svcmd + "("    
                 if l_max2 <> -1 then
                    for i = 0 to l_max2
                       if i <> 0 then myline = myline +", "
                       myline = myline + svpar2(i)              
                    next      
                 end if
                 myline = myline + ");"  + chr(10)
''                 myline = myline + "       union {byte array[4]; uint32_t arr; } Convert;"+chr(10)                    
                 myline = myline + "       uint16_t len = ??; //raw.size() or fixe value depending of the arduino part" +chr(10)
                 myline = myline + "       ArrayULong* arr = CreateStackMemoryObject(ArrayULong);" +chr(10)
                 myline = myline + "       arr->data=raw;"  +chr(10)
                 myline = myline + "       arr->length=len;"  +chr(10)
                 myline = myline + "       return arr;" +chr(10)              
                 myline = myline + "    };" + chr(10)  +chr(10)
                 mychaine = mychaine + myline
                 flag_code = "1"     
                 
              elseif (linetype= "ArrayDouble*") and (linetypeAV="float *") then    'case array Double from float*'   
                 myline = myline + "       float* raw = rcs->" + svcmd + "("    
                 if l_max2 <> -1 then
                    for i = 0 to l_max2
                       if i <> 0 then myline = myline +", "
                       myline = myline + svpar2(i)              
                    next      
                 end if
                 myline = myline + ");"  + chr(10)           
                 myline = myline + "       uint16_t len = ??; //raw.size() or fixe value depending of the arduino part" +chr(10)
                 myline = myline + "       ArrayDouble* arr = CreateStackMemoryObject(ArrayDouble);" +chr(10)
                 myline = myline + "       arr->data=raw;"  +chr(10)
                 myline = myline + "       arr->length=len;"  +chr(10)
                 myline = myline + "       return arr;" +chr(10)              
                 myline = myline + "    };" + chr(10)  +chr(10)
                 mychaine = mychaine + myline
                 flag_code = "1"    
                 
              
              elseif (linetype= "ArrayDouble*") and (linetypeAV="double *") then    'case array Double from double *'   
                                                                                     'we must adapt 8 bits on esp8266 to 4 bits in B4X
                 myline = myline + "       double* raw = rcs->" + svcmd + "("    
                 if l_max2 <> -1 then
                    for i = 0 to l_max2
                       if i <> 0 then myline = myline +", "
                       myline = myline + svpar2(i)              
                    next      
                 end if
                 myline = myline + ");"  + chr(10)
                 myline = myline + "       union {byte array[4]; float arr; } Convert;"+chr(10)                        
                 myline = myline + "       uint16_t len = ??; //raw.size() or fixe value depending of the arduino part" +chr(10)
                 myline = myline + "       ArrayByte* arr = CreateStackMemoryObject(ArrayByte);" +chr(10)
                 myline = myline + "       arr->data = (StackMemory::buffer + StackMemory::cp);" +chr(10)
                 myline = myline + "       for (uint16_t i = 0;i < len; i++) { " +chr(10)
                 myline = myline + "         Convert.arr = raw[i];"+chr(10)       
                 myline = myline + "         for (uint16_t j = 0; j < 4; j++) {"+chr(10)    
                 myline = myline + "         StackMemory::buffer[StackMemory::cp++] =Convert.array[j];"+chr(10) 
                 myline = myline + "         }"+chr(10)                              
                 myline = myline + "       }"+chr(10)
                 myline = myline + "       arr->length=len;"  +chr(10)
                 myline = myline + "       return arr;" +chr(10)              
                 myline = myline + "    };" + chr(10)  +chr(10)
                 mychaine = mychaine + myline
                 flag_code = "1"    
                            
              elseif (linetype= "B4RString*") and (linetypeAV="String") then    'case B4RString from string
                 myline = myline + "       String rax = rcs->" + svcmd + "("    
                 if l_max2 <> -1 then
                    for i = 0 to l_max2
                       if i <> 0 then myline = myline +", "
                       myline = myline + svpar2(i)              
                    next      
                 end if
                 myline = myline + ");"  + chr(10)
                 myline = myline + "       PrintToMemory pm;"  + chr(10)
                 myline = myline + "       B4RString* s = B4RString::PrintableToString(NULL);"  + chr(10)
                 myline = myline + "       pm.print(rax);"  + chr(10)
                 myline = myline + "       StackMemory::buffer[StackMemory::cp++] = 0;"  + chr(10)
                 myline = myline + "       return s;"  + chr(10)          
                 myline = myline + "    };" + chr(10)  +chr(10)
      
                 mychaine = mychaine + myline
                 flag_code = "1"                
                
              elseif (linetype= "B4RString*") and (linetypeAV="IPAddress") then    'case B4RString from IPAddress
             	 myline = myline + "       IPAddress ip = rcs->" + svcmd + "("    
                 if l_max2 <> -1 then
                    for i = 0 to l_max2
                       if i <> 0 then myline = myline +", "
                       myline = myline + svpar2(i)              
                    next      
                 end if
                 myline = myline + ");"  + chr(10) 
                 myline = myline + "       return B4RString::PrintableToString(&ip);"  +chr(10)
                 myline = myline + "    };" + chr(10)  +chr(10)       
                 mychaine = mychaine + myline  
                 flag_code = "1"    
  
              elseif (linetype= "B4RString*") and (linetypeAV="char *") then    'case B4RString from char*
                 myline = myline + "       char* raw = rcs->" + svcmd + "("    
                 if l_max2 <> -1 then
                    for i = 0 to l_max2
                       if i <> 0 then myline = myline +", "
                       myline = myline + svpar2(i)              
                    next      
                 end if
                 myline = myline + ");"  + chr(10)
                 myline = myline + "       B4RString* arr = CreateStackMemoryObject(B4RString);"   +chr(10)
                 myline = myline + "       arr->data = raw;"  +chr(10)
                 myline = myline + "       return arr;" +chr(10)              
                 myline = myline + "    };" + chr(10)  +chr(10)
                 mychaine = mychaine + myline
                 flag_code = "1"               
                                                                                    
              elseif linetype= "B4RStream*" then    'case B4RSteam
             	 myline = myline + "       return = rcs->" + svcmd + "("    
                 if l_max2 <> -1 then
                    for i = 0 to l_max2
                       if i <> 0 then myline = myline +", "
                       myline = myline + svpar2(i)              
                    next      
                 end if
                 myline = myline + ");"  + chr(10) 
                 myline = myline + "    };" + chr(10)  +chr(10)       
                 mychaine = mychaine + myline 
                 flag_code = "1"           
                                                          
              else                                 'next lines others cases byte, int, uint, long, ulong, double,etc...'
                 myline = myline + "       return "+ "rcs->" + svcmd + "("    
                 if l_max2 <> -1 then
                    for i = 0 to l_max2
                       if i <> 0 then myline = myline +", "
                       myline = myline + svpar2(i)              
                    next      
                 end if
                 myline = myline + ");"  + chr(10)
                 myline = myline + "    };" + chr(10)  +chr(10)
                 mychaine = mychaine + myline   
                 flag_code = "1" 
              end if   
                          'case { code } code added at code in h file
              if flag_code = "1" and j <> ubound(myarray) then 
                 if left(trim(myarray(j+1)),1) = "{" then 
 ''                   logaddline(myarray(j+1))
                    myarray(j+1)= "" '// "+ myarray(j+1)
                    if left(trim(myarray(j+2)),1) = "}" then 
                       myarray(j+2)= "" '// "+ myarray(j+2)  
                    else
''                       logaddline(myarray(j+3))
                       myarray(j+2)= "" '// "+ myarray(j+2)  
                       myarray(j+3)= "" '// "+ myarray(j+3)  
                    end if                                                              
        
                 end if
                 flag_code = ""
              end if   
           end if
         end if
         
         if left(myline,5) = "enum "  then                    'case ENUM'              enum = 1       enum = 0       enum = 0 not enum
            myenum = "1" ': myenum1 = "B4RV"+ucase(trim(+mid(myline,6))) 
            if instr(myline,":")> 0 then 
               myenum1 = "B4RV"+ucase(trim(+mid(myline,6,instr(myline,":")-6)))          
               myenum2 =  trim(mid(myline,instr(myline,":")+1) )
           else
                myenum1 = "B4RV"+ucase(trim(+mid(myline,6))) 
               myenum2 =  "?????"
               logaddline (" enum without type of variable =>part missing like [:byte]")
            end if   
            myline = "//enum    //~shortname:"+ mid(myenum1,5) + chr(10)  
''            myline = "//enum     };"+chr(10)+"//enum    //~shortname:"+ mid(myenum1,5) + chr(10)              
            myline = myline +"//enum     class "+ myenum1 +chr(10) +"//enum     {"+chr(10)+"//enum        public:" 
            mychaine2 = mychaine2 + myline +chr(10)
            myarray(j)=""
''          logaddline("myenum0="+myenum)
         elseif myenum = "1" then 
''            logaddline("myenum1="+myenum)
            if left(myline,1) = "{" then
               myenum = "2"
               myarray(j)=""
   
            elseif left(myline,1) = "}" then
               myenum = "0"
               myarray(j)=""
            end if
         elseif myenum = "2"  then
            if left(myline,1) = "}" then 
               myenum = "0"
               mychaine2 = mychaine2 +"//enum     }"+chr(10)
               myarray(j)=""
''             logaddline("myenum2="+myenum)
            else
               if instr(myline,"=")> 0 then
                 myline = "//enum           #define /*"+myenum2+" " +ucase(trim(left(myline,instr(myline,"=")-1)))+";*/ " + myenum1 +"_" + ucase(trim(left(myline,instr(myline,"=")-1)))  + " "+ myclass+"::" +trim(left(myline,instr(myline,"=")-1))                 
               else
                 myline = "//enum           #define /*"+myenum2+" "+ ucase(trim(left(myline,instr(myline," "))))+";*/ " +myenum1 +"_" + ucase(trim(left(myline,instr(myline," "))))  + " "+ myclass+"::" +trim(left(myline,instr(myline," ")))
               end if
               mychaine2 = mychaine2 + myline +chr(10) 
               myarray(j) = ""
''             logaddline("myenum="+myenum)
            end if
         end if
        
        if trim(myarray(j)) <> "" then 
           mychaine = mychaine + "//?? "+ myarray(j) +chr(10)
           myarray(j) = ""
        end if     '*****************'
     end if      
  next  
  mychaine = mychaine +chr(10) + mychaine2 
  mychaine = mychaine + "}" + chr(10)
''  case callback : we have to add link from original library
  if mycbkB1 <> "" then 
       mytemp = wordsplit(mycbkB1) 
       mytmp = split(mycbkP1,",") 
       myline = ""
       for i = 0 to ubound(mytmp)
           if myline <> "" then 
              myline = myline + ", "+mid(mytmp(i), instrrev(mytmp(i)," ")+1)
           else 
              myline = myline + mid(mytmp(i), instrrev(mytmp(i)," ")+1)
           end if   
       next    
       mychaine = mychaine +"    "+mytemp(0)+" "+mid(B4Rname,4)+"::"+ mytemp(1)+"("+mycbkP1+")"+chr(10)+"    {"+chr(10)  
       mychaine = mychaine +"       B4R::"+ B4Rname+"::"+mytemp(1)+"("+myline+");"+chr(10)  
       mychaine = mychaine +"    };"+chr(10)  

      if mycbkB2 <> "" then 
       mytemp = wordsplit(mycbkB2) 
       mytmp = split(mycbkP2,",") 
       myline = ""
       for i = 0 to ubound(mytmp)
           if myline <> "" then 
              myline = myline + ", "+mid(mytmp(i), instrrev(mytmp(i)," ")+1)
           else 
              myline = myline + mid(mytmp(i), instrrev(mytmp(i)," ")+1)
           end if   
       next    
       mychaine = mychaine +"    "+mytemp(0)+" "+mid(B4Rname,4)+"::"+ mytemp(1)+"("+mycbkP2+")"+chr(10)+"    {"+chr(10)  
       mychaine = mychaine +"       B4R::"+ B4Rname+"::"+mytemp(1)+"("+myline+");"+chr(10)  
       mychaine = mychaine +"    };"+chr(10) 
      end if 
      if mycbkB3 <> "" then 
       mytemp = wordsplit(mycbkB3) 
       mytmp = split(mycbkP3,",") 
       myline = ""
       for i = 0 to ubound(mytmp)
           if myline <> "" then 
              myline = myline + ", "+mid(mytmp(i), instrrev(mytmp(i)," ")+1)
           else 
              myline = myline + mid(mytmp(i), instrrev(mytmp(i)," ")+1)
           end if   
       next    
       mychaine = mychaine +"    "+mytemp(0)+" "+mid(B4Rname,4)+"::"+ mytemp(1)+"("+mycbkP3+")"+chr(10)+"    {"+chr(10)  
       mychaine = mychaine +"       B4R::"+ B4Rname+"::"+mytemp(1)+"("+myline+");"+chr(10)  
       mychaine = mychaine +"    };"+chr(10) 
      end if 
  end if        
  mychaine = replace(mychaine,chr(13),"")
  mychaine = replace(mychaine,"//?? {"+chr(10),"")
  mychaine = replace(mychaine,"//?? }"+chr(10),"")
  obj2.text (mychaine)       
         
  logAddLine("end file.cpp creation")
  sleep(100)      
  end sub                                                                                                                  



  '===============================================' 
 'B4Rlibrary Phase 2
 ' [h creation] for B4R from xxx.cpp file for B4R
 ' GLOBAL script
 '===============================================' 
sub h_create
   dim i, j,myline ,l_p1,l_p2,l_p3,l_p4,l_p5,l_p6,l_p7 ,namespace ,myclass, myclass2, myevent
   dim  mytemp1, mytemp, mytemp_max, mytmp, mytmp1, mytmp2, mytmp3, mychaine1
   
   set obj1 = NewEditor()           'new editor object
   set obj2 = NewEditor()           'new editor object       
   obj1.assignActiveEditor         'assign PSPad window active to obj1
   myfilename =  obj1.filename
   logclear
''   logaddline(myfilename)
 ''  logclear
   fi = instr(myfilename,".")
   fj = instrrev(myfilename,"\")   
   obj2.NewFile(left(myfilename,fi) + "h" )
   myfilename = mid(myfilename,fj+1,fi-fj-1)
   B4Rname = "B4R"+ mid(myfilename,2)
   logaddline("B4Rname="+B4Rname)
   mychaine = obj1.text
   mychaine = replace(mychaine,chr(13),"")
   mychaine = replace(mychaine,chr(09),"    ")
   myarray = split(mychaine,chr(10))
   l_max = ubound(myarray)
     
   if confinit = false then exit sub           'analysis of configuration'
      
   mychaine = "" : mychaine1=""      'chaine = Private part / chaine1 = Public part'
   for i = 0 to 17
     mychaine = mychaine +myarray(i) + chr(10)
     myarray(i) = "" 
   next   

   mychaine = mychaine + "#pragma once" + chr(10)
   mychaine = mychaine + "#include "+chr(34)+"B4RDefines.h"+chr(34)+chr(10)
   mychaine = mychaine +"#include "+chr(34)+ mid(myfilename,2)+".h"+ chr(34)+    chr(10)  +chr(10) 

   if mybackend = "N" or (myeventB1="" and myeventB2="" and myeventB3="" and mycbkB1="" and mycbkB2=""and mycbkB3="") then 
      mychaine = mychaine +  "    //~Event: "    +chr(10)  
   else                                                                                 
     if myeventB1 <> "" then    mychaine = mychaine+createvent(myloopConf1,myeventP1)+chr(10)
     if myeventB2 <> "" then    mychaine = mychaine+createvent(myloopConf2,myeventP2)+chr(10)   
     if myeventB3 <> "" then    mychaine = mychaine+createvent(myloopConf3,myeventP3)+chr(10)               
     if mycbkB1 <> "" then    mychaine = mychaine+createvent(mycbkConf1,mycbkP1)+chr(10)
     if mycbkB2 <> "" then    mychaine = mychaine+createvent(mycbkConf2,mycbkP2)+chr(10)
     if mycbkB3 <> "" then    mychaine = mychaine+createvent(mycbkConf3,mycbkP3)+chr(10)     
   end if
   mychaine = mychaine +  "    //~Version: 1.0 "  +chr(10)  
   mychaine = mychaine +  "    //~Author - "  +chr(10)  
   mychaine = mychaine +  "    //~Libray from Arduino"   +chr(10)  +chr(10) 
   mychaine = mychaine +"namespace B4R {"+chr(10)    
   'add typedef
   if myeventB1 <> "" then    mychaine = mychaine+creattypedef(myloopConf1,myeventP1)+chr(10)
   if myeventB2 <> "" then    mychaine = mychaine+creattypedef(myloopConf2,myeventP2)+chr(10)
   if myeventB3 <> "" then    mychaine = mychaine+creattypedef(myloopConf3,myeventP3)+chr(10)  
   if mycbkB1 <> "" then    mychaine = mychaine+creattypedef(mycbkConf1,mycbkP1)+chr(10)
   if mycbkB2 <> "" then    mychaine = mychaine+creattypedef(mycbkConf2,mycbkP2)+chr(10)
   if mycbkB3 <> "" then    mychaine = mychaine+creattypedef(mycbkConf3,mycbkP3)+chr(10)    

   namespace = 0  : myclass = ""
   for j = 0 to l_max
      myline = trim(myarray(j))
      logaddline(j)
      if myline = "" then 
         myline = ""
      elseif left(myline,2)="//"then              'case line comment'
         mychaine = mychaine + myarray(j) +chr(10)    
      elseif left(myline,9) = "namespace" then
         namespace = 1  
         if instr(myline, "{")> 0 then namespace = namespace +1
'//         if instr(myline,"}")> 0 and namespace > 1 then namespace = namespace -1
      elseif namespace > 0 then
         l_p1 = instr(myline," ")
         l_p2 = instr(myline,"::")
         l_p3 = instr(myline,"(")
         l_p4 = instr(myline,".")
         l_p5 = instr(myline,";")
         l_p6 = instr(myline,"{")
         l_p7 = instr(myline,"}")
         if l_p6 > 0 then namespace = namespace + 1
         if l_p7 > 0 and namespace > 1 then
             namespace = namespace - 1
             if namespace = 1 then namespace = 0
         end if    
''         logaddline(l_p1)
''         logaddline(l_p2)    
''         logaddline(myline)
''         logaddline(namespace)
         if mybackend = "N" then      'case no event'
            if l_p6<1 and l_p7 < 1 and l_p3 < 1 and l_p4<1 and l_p5 > 0 then   'no"{", no"}", no"(", yes";"", no "."       => process to run
               if myclass <> "" then mychaine = mychaine + "    }" +chr(10)  +chr(10)
               mychaine = mychaine +  "    //~shortname:" +left(myline,instr(myline," "))  +chr(10)  
               myclass = "class B4R"+ left(myline,instr(myline," ")) '+ chr(10)
               mychaine = mychaine + "    "+myclass +chr(10)  +  "    {" +chr(10)
               mychaine = mychaine + "        private:" +chr(10)
               mychaine = mychaine + "            " + myline + chr(10)
               mychaine = mychaine + "        public:" +chr(10)
            elseif l_p2 > 0 and l_p1 > 0 then
                mychaine = mychaine + "            "+left(myline,l_p1-1)+" " + mid(myline,l_p2+2)+";" +chr(10)
            end if
         else                   'case with event'
            if l_p2 > 0 and l_p1 > 0 and l_p5<1 and l_p3>0 then      'case first sub                      'yes"::", yes " ", no";", yes"(" => sub line
               myclass2 = mid(myline,l_p1+1,l_p2-l_p1-1)
''               logaddline("myclass2="+myclass2+"|")
''               logaddline("myclass="+myclass+"|")
               if myclass <> myclass2 then     'new case'
                  if myclass <> "" then mychaine = mychaine + "    }" +chr(10)  +chr(10)
                  myclass = myclass2
                  mychaine = mychaine +  "    //~shortname:" + mid(myclass2,4)  +chr(10)  
                  mychaine = mychaine + "    class "+ myclass2 + chr(10)+"    {"  + chr(10)
                  
                  mychaine = mychaine + "        private:" +chr(10)     
                  if mycbkB1 <> "" then mychaine = mychaine +"            static "+ B4Rname+"* instance;"+chr(10)  
                  mychaine = mychaine + "            uint8_t backend[sizeof("+ mid(myclass2,4)  +")];"  + chr(10)
			      mychaine = mychaine + "            "+mid(myclass2,4) +"* rcs;"  + chr(10)
                  if myeventB1 <> "" then  mychaine = mychaine + "            PollerNode pnode;"  + chr(10)
                  if myeventB1 <> "" then    mychaine = mychaine+creatsubvoid(myloopConf1)+chr(10)                     
                  if myeventB2 <> "" then    mychaine = mychaine+creatsubvoid(myloopConf2)+chr(10)   
                  if myeventB3 <> "" then    mychaine = mychaine+creatsubvoid(myloopConf3)+chr(10)  
              
                  if mycbkB1 <> "" then    mychaine = mychaine+creatsubvoid(mycbkConf1)+chr(10)
                  if mycbkB2 <> "" then    mychaine = mychaine+creatsubvoid(mycbkConf2)+chr(10)
                  if mycbkB3 <> "" then    mychaine = mychaine+creatsubvoid(mycbkConf3)+chr(10)     
''                  if mycbkB1 <> "" then    mychaine = mychaine +"        public:"+chr(10)                                  
		          mychaine1 = mychaine1 + "        public: "  + chr(10)
                  mychaine1 = mychaine1 + "            "+left(myline,l_p1-1)+" " + mid(myline,l_p2+2)+";" +chr(10)
               else 
                  logaddline(private0+"|"+private1+"|"+private2+"|"+private3) 
                  logaddline(myline)
                  if instr(myline,private1)<1 and instr(myline,private2)<1 and instr(myline,private3)<1 and instr(myline,private0)<1 then        'looper is in private part'
                     mychaine1 = mychaine1 + "            "+left(myline,l_p1-1)+" " + mid(myline,l_p2+2)+";" +chr(10)  
                  elseif instr(myline,private0)>0 then
                     mychaine = mychaine + "            static "+left(myline,l_p1-1)+" " + mid(myline,l_p2+2)+";" +chr(10)               
                  else
                     mychaine1 = mychaine1 + "            static "+left(myline,l_p1-1)+" " + mid(myline,l_p2+2)+";" +chr(10)    
                  end if       
               end if
            end if      
         end if   
      end if   
   next  
   mychaine = mychaine + mychaine1        
   mychaine = mychaine +"    };" + chr(10)
   mychaine = mychaine +"}" + chr(10)    
   mychaine = replace(mychaine,"//enum","")      'add #define parameters'
   mychaine = replace(mychaine,chr(13),"")
   obj2.text (mychaine)       
         
   logAddLine("end file.h creation")
   sleep(100)      
end sub  
 



 
 '===============================================' 
 'B4Rlibrary Phase 3
 '' create xml file for B4R from h file
 ' GLOBAL script
 '===============================================' 
sub xml_create
   dim i, j,myline , l_p1, l_p2, l_p3, l_p4, l_p5, myreturn, myname  ,myevent, mycomment , mypara ,mypublic, myclass, mylineS, mylineNB, B4RnameShort, mystruct
   dim multievent
   set obj1 = NewEditor()           'new editor object
   set obj2 = NewEditor()           'new editor object       
   obj1.assignActiveEditor         'assign PSPad window active to obj1
    myfilename =  obj1.filename

   logclear
   fi = instr(myfilename,".")
   fj = instrrev(myfilename,"\")
   obj2.NewFile(left(myfilename,fi)+"xml" )
   myfilename = mid(myfilename,fj+2,fi-fj-2)
   B4Rname = "B4R"+ myfilename
   logaddline("B4Rname="+B4Rname)

   mychaine = obj1.text
   mychaine = replace(mychaine,chr(13),"")
   mychaine = replace(mychaine,chr(09),"    ")
   myarray = split(mychaine,chr(10))
   l_max = ubound(myarray)
   B4Rname  =""

   mychaine = "<?xml version=""1.0"" encoding=""UTF-8"" standalone=""no""?>" + chr(10)
   mychaine = mychaine + "<root>" + chr(10)
   mychaine = mychaine + "    <doclet-version-NOT-library-version>1.00</doclet-version-NOT-library-version>" + chr(10)

   
   for j = 4 to l_max                      'case event to add at file'
      logaddline(j)
      myline = trim(myarray(j)) 
      l_p1 = instr(myline," ")
      l_p2 = instr(myline,"(")
      l_p3 = instr(myline,")")
      l_p4 = instr(myline,"=")
      l_p5 = instr(myline,",")
''      logaddline(myline)

      if myline = "" then
         myarray(j)=""
      elseif left(myline,2) = "/*" then
         mycomment = 1 
''         logaddline("start comment")
         myarray(j)="" 
      elseif left(myline,2)= "*/"  then
          mycomment = 0   
''          logaddline("stop comment") 
          myarray(j)=""
      elseif mycomment = 1 then
''        logaddline("comment")
         myarray(j)=""
           
      ''case struct definition  
      elseif left(myline,9)= "//~Event:"  then  'case event'
         myevent = trim(mid(myline,10))
         multievent = multievent + "         <event>"+myevent+"</event>" +chr(10)
''         logaddline("===> event")
         myarray(j) = ""  
''      elseif left(myline,2)= "//"  then 
''        myarray(j) = "" 
     ''case comment line  
      elseif  left(myline,13)= "//~shortname:" then
          B4RnameShort = trim(mid(myline,14))
      elseif left(myline,2)= "//" then
         myarray(j) = ""

      elseif left(myline,6) = "struct" then
         mystruct = 1 
''         logaddline("start struct")
         myarray(j)="" 
      elseif  left(myline,1)= "}" and  mystruct = 1  then   
''         logaddline("stop struct") 
         myarray(j)=""
         mystruct = 0
      elseif left(myline,1)= "}" and  myclass = 1  then
          B4RnameShort = ""
          B4Rname = ""
          mypublic = 0
          myclass = 0
          myarray(j)=""
          mychaine = mychaine + "    </class>" + chr(10)
      elseif left(myline,1)= "}"  then
          mychaine = mychaine + "//?? "+myarray(j) + chr(10)             
          myarray(j)=""
      elseif mystruct = 1 then
''          logaddline("struct")
          myarray(j)=""
'         logaddline("------> line erased "+myline)          
      elseif left(myline,5)= "class"  then  'case name of library to add at xml'
          B4Rname = trim(mid(myline,6))   
          myclass = 1 
          if  B4RnameShort = "" then B4RnameShort = mid(B4Rname,4)      
''          logaddline(B4Rname)
          mychaine = mychaine + "    <class>" + chr(10)
          mychaine = mychaine + "        <name>B4R::" + B4Rname + "</name>" + chr(10)
          mychaine = mychaine + "        <shortname>" + B4RnameShort + "</shortname>" + chr(10)
          mychaine = mychaine + "        <comment>"+ chr(10)
          mychaine = mychaine + "            Example: &lt;code&gt; " + chr(10)
''          mychaine = mychaine + "            Private rcs As " + mid(B4Rname,4) + chr(10)
          mychaine = mychaine + "            &lt;/code&gt;</comment>" + chr(10)          
          myarray(j) = ""
          mychaine = mychaine + multievent : multievent = ""
      elseif left(myline,7)="public:"  then 
         mypublic = 1
''         logaddline("===> public")
      elseif mypublic = 0 then 
          myarray(j)=""
      elseif left(myline,7) = "#define" then                                                                      'case field [ #Define \*comment*\ <variable>  <value> ]      
         mylineS = wordsplit(myline)                                                                              ' or          [ #Define <variable>  <value> ]
         mylineNB = ubound(mylineS)
'        logaddline(mylineS(1))
         if left(mylineS(1),2) <> "/*" then 
           myname = replace(mylineS(1),B4Rname+"_","")
           mychaine = mychaine +"        <field>" + chr(10)
           mychaine = mychaine +"            <name DefineMethod="+chr(34)+"true"+chr(34)+" DesignerName="+chr(34)+myname+chr(34)+">"+mylineS(1)+"</name>" + chr(10)    
           mychaine = mychaine +"            <returntype>"+"uint"+"</returntype>" + chr(10)        
           mychaine = mychaine +"        </field>" + chr(10)         
           myarray(j) = ""      
        else
           myreturn = mid(mylineS(1),3)
           myname = left(mylineS(2), len(mylineS(2))-3)
''           myname =  mid(mylineS(1),instr(mylineS(1)," ")+1, len(mylineS(1))-instr(mylineS(1)," "))   
''           myname = replace(myname,B4Rname+"_","")                                                              'case with comment /*int16_t field_name*/
           mychaine = mychaine +"        <field>" + chr(10)
           mychaine = mychaine +"            <name DefineMethod="+chr(34)+"true"+chr(34)+" DesignerName="+chr(34)+myname+chr(34)+">"+mylineS(3)+"</name>" + chr(10)    
           mychaine = mychaine +"            <returntype>"+myreturn+"</returntype>" + chr(10)        
           mychaine = mychaine +"        </field>" + chr(10)         
           myarray(j) = ""      
        end if 
        
      elseif l_p1>0 and l_p2<1 and l_p3<1 and l_p4<1then                                                          'case field [ <type> <variable> ]
         mylineS = wordsplit(myline)                                                                    
         mylineNB = ubound(mylineS)        
         myname = mylineS(1)
         myreturn = xml_returnmod(mylineS(0))
    
         mychaine = mychaine +"        <field>" + chr(10)
         mychaine = mychaine +"            <name DesignerName="+chr(34)+myname+chr(34)+">"+myname+"</name>" + chr(10)    
         mychaine = mychaine +"            <returntype>B4R::"+myreturn+"</returntype>" + chr(10)        
         mychaine = mychaine +"        </field>" + chr(10)         
         myarray(j) = ""
 
      elseif l_p1>0 and l_p2<1 and l_p3<1 and l_p4>0 then                                                         'case field [ <type> <variable = <value>  ]

         mylineS = wordsplit(myline)                                                                    
         mylineNB = ubound(mylineS)        
         myname = mylineS(1)
         myreturn = xml_returnmod(mylineS(0))
    
         mychaine = mychaine +"        <field>" + chr(10)
         mychaine = mychaine +"            <name DesignerName="+chr(34)+myname+chr(34)+">"+myname+"</name>" + chr(10)    
         mychaine = mychaine +"            <returntype>"+myreturn+"</returntype>" + chr(10)        
         mychaine = mychaine +"        </field>" + chr(10)         
         myarray(j) = ""        

      elseif (mid(myline,1,l_p1-1)) = "static" then
         ' case static function in public part for callback => to ignore' 

      elseif lcase(mid(myline,l_p1+1,3)) = "_get" then                                                                    'case property = GET with return  and without parameter '
         myreturn = trim(left(myline,l_p1-1))                                                                     ' => GET is removed
         myreturn = xml_returnmod(myreturn)
         myname = trim(mid(myline,l_p1+4,l_p2-l_p1-4))  ': if left(myname,3)= "get" then myname = mid(myname,4)
         mychaine = mychaine +"        <property>" + chr(10)
         mychaine = mychaine +"            <name>"+myname+"</name>" + chr(10)
         mychaine = mychaine +"            <comment>" + chr(10)
         mychaine = mychaine +"                Example: &lt;code&gt;" + chr(10)
''         mychaine = mychaine +"Log(""Code: "", rcs."+myname+")" + chr(10)
         mychaine = mychaine +"                &lt;/code&gt;</comment>" + chr(10)           
         mychaine = mychaine +"            <returntype>"+myreturn+"</returntype>" + chr(10)
         mychaine = mychaine +"        </property>" + chr(10)  
         myarray(j) = ""

      elseif lcase(mid(myline,l_p1+1,3))="_set" and l_p3<>l_p2+1 and l_p5<1 and right(myline,7)<> "//#Meth" then               '        'case property = SET with 1 parameter     => SET is removed
         myname = trim(mid(myline,l_p1+4,l_p2-l_p1-4))  ': if left(myname,3)= "SET" then myname = mid(myname,4)   'if parameter //#Meth at end of line, it will be Methode
         mypara = trim(mid(myline,l_p2+1,l_p3-l_p2-1) )                                                               
         if mypara <> ""   then
            svpar1 = split(mypara,",")
            svpar2 = split(mypara,",")    
            l_max2 = ubound(svpar1)
 ''         logaddline(l_max2) 
            for i = 0 to l_max2  
               svpar1(i) = trim(svpar1(i)) :  svpar2(i) = trim(svpar2(i)) 
               l_p1 = instr(svpar1(i)," ")
               svpar1(i) = trim(left(svpar1(i),l_p1 )) 
               svpar1(i) = xml_returnmod(svpar1(i))                                 
               svpar2(i) = trim(mid(svpar2(i),l_p1+1))    
 ''              logaddline(svpar1(i)+"--"+svpar2(i))                    
            next  
         end if 
         mychaine = mychaine +"        <property>" + chr(10)
         mychaine = mychaine +"            <name>"+myname+"</name>" + chr(10)
         mychaine = mychaine +"            <comment>" + chr(10)
         mychaine = mychaine +"                Example: &lt;code&gt;" + chr(10)
 ''        mychaine = mychaine +"Log(""Code: "", rcs."+myname+")" + chr(10)
         mychaine = mychaine +"                &lt;/code&gt;</comment>" + chr(10)
         if mypara <> "" then
            for i = 0 to l_max2
               mychaine = mychaine +"            <parameter>"+chr(10)                          
               mychaine = mychaine +"                <name>"+svpar2(i)+"</name>"+chr(10)
               mychaine = mychaine +"                <type>"+svpar1(i)+"</type>"+chr(10)
               mychaine = mychaine +"            </parameter>"+chr(10)     
            next   
         end if          
         mychaine = mychaine +"        </property>" + chr(10)  
         myarray(j) = ""                      
         
      elseif  instr(myline,"()") > 0 and (left(myline,4) = "void") then                                           'case Method = "void" without parameter
''         myname = trim(mid(myline,l_p1+1,l_p2-l_p1-1))  ': if left(myname,3)= "get" then myname = mid(myname,4)
         myreturn = trim(left(myline,l_p1-1))  
         myreturn = xml_returnmod(myreturn)
         myname = trim(mid(myline,l_p1+1,l_p2-l_p1-1) )   ': if left(myname,3)= "set" then myname = mid(myname,4)   
        
         mychaine = mychaine +"        <method>" + chr(10)
         mychaine = mychaine +"            <name DesignerName="+chr(34)+myname+chr(34)+">"+myname+"</name>" + chr(10) 
         mychaine = mychaine +"            <comment>" + chr(10)
         mychaine = mychaine +"                Example: &lt;code&gt;" + chr(10)
''         mychaine = mychaine +"Log(""Code: "", rcs."+myname+")" + chr(10)
         mychaine = mychaine +"                &lt;/code&gt;</comment>" + chr(10) 
         mychaine = mychaine +"            <returntype>B4R::void</returntype>" + chr(10)
         mychaine = mychaine +"        </method>" + chr(10)  
         myarray(j) = ""  
         
      elseif instr(myline,"(") > 0   then                                                                         'case Method = multi parameters and with or without return '
''         logaddline(l_p1)
''         logaddline(l_p2)
''         logaddline(l_p3)
         myreturn = trim(left(myline,l_p1-1))
         myreturn = xml_returnmod(myreturn) 
         myname = trim(mid(myline,l_p1+1,l_p2-l_p1-1) )  ': if left(myname,3)= "set" then myname = mid(myname,4)
         
         mypara = trim(mid(myline,l_p2+1,l_p3-l_p2-1) )
''         logaddline("mypara="+mypara+"-")
         if mypara <> ""   then
            svpar1 = split(mypara,",")
            svpar2 = split(mypara,",")    
            l_max2 = ubound(svpar1)
 ''         logaddline(l_max2) 
            for i = 0 to l_max2  
               svpar1(i) = trim(svpar1(i)) :  svpar2(i) = trim(svpar2(i)) 
               l_p1 = instr(svpar1(i)," ")
               svpar1(i) = trim(left(svpar1(i),l_p1 )) 
               svpar1(i) = xml_returnmod(svpar1(i))                                              
               svpar2(i) = trim(mid(svpar2(i),l_p1+1))    
 ''              logaddline(svpar1(i)+"--"+svpar2(i))                    
            next  
         end if
         mychaine = mychaine +"        <method>" + chr(10)
         mychaine = mychaine +"            <name DesignerName="+chr(34)+myname+chr(34)+">"+myname+"</name>" + chr(10)    
         mychaine = mychaine +"            <comment>" + chr(10)
         mychaine = mychaine +"                Example: &lt;code&gt;" + chr(10)
 ''        mychaine = mychaine +"Log(""Code: "", rcs."+myname+")" + chr(10)
         mychaine = mychaine +"                &lt;/code&gt;</comment>" + chr(10)
         mychaine = mychaine +      "                 <returntype>"+myreturn+"</returntype>" + chr(10)
         if mypara <> "" then
            for i = 0 to l_max2
               mychaine = mychaine +"            <parameter>"+chr(10)                          
               mychaine = mychaine +"                <name>"+svpar2(i)+"</name>"+chr(10)
               mychaine = mychaine +"                <type>"+svpar1(i)+"</type>"+chr(10)
               mychaine = mychaine +"            </parameter>"+chr(10)     
            next   
         end if          
         mychaine = mychaine +"        </method>" + chr(10)  
         myarray(j) = ""
      else
         if myline <> "" then mychaine = mychaine + "????" + myline + chr(10)
      end if
   next    
   'end of file'
''   mychaine = mychaine +"    </class>" +chr(10)
   mychaine = mychaine +"    <version>1</version>" + chr(10) 
   mychaine = mychaine +"</root>" + chr(10)
   
'' check for errors in xml file   
   if instr(mychaine,"<name></") >0 then l_p5= msgbox("Error in xml file"+chr(10)+" name error - '<name></name>' found ",16)
   if instr(mychaine,"<type></") >0 then l_p5= msgbox("Error in xml file"+chr(10)+" type error - '<type></type>' found ",16)
   if instr(mychaine,"<returntype></") >0 then l_p5= msgbox("Error in xml file"+chr(10)+" returntype error - '<returntype></returntype>' found",16)                                                                                                                              
 
   mychaine = replace(mychaine,"//?? }"+chr(10),"")
   mychaine = replace(mychaine,chr(13),"")                                                                                                                             
   mychaine = replace(mychaine,chr(13),"")
                                                                                                                                 
   mychaine = replace(mychaine,chr(13),"")
   obj2.text (mychaine)       
         
   logAddLine("end file.xml creation")
   sleep(100)     
  end sub  

  
  '==============================================' 
  ' B4Rlibrary - [xml creation] rename needed in xml format
  
  '==============================================' 
  function xml_returnmod(myreturn)
    if myreturn = "void" then 
      myreturn ="B4R::void"
    elseif myreturn = "bool" then 
      myreturn ="Bool"       
    elseif myreturn = "byte" then 
      myreturn ="Byte"      
    elseif myreturn = "int16_t" then 
      myreturn ="Int"
    elseif myreturn = "uint16_t" then 
      myreturn ="UInt"
    elseif myreturn = "int32_t" then 
      myreturn ="Long"
    elseif myreturn = "uint32_t" then 
      myreturn ="ULong" 
    elseif myreturn = "double" then 
      myreturn ="Double"            
    elseif myreturn = "ArrayByte*" then 
      myreturn ="Byte[]"
    elseif myreturn = "ArrayInt*" then 
      myreturn ="Int[]"
    elseif myreturn = "ArrayUInt*" then 
      myreturn ="UInt[]"
    elseif myreturn = "ArrayLong*" then 
      myreturn ="Long[]"
    elseif myreturn = "ArrayULong*" then 
      myreturn ="ULong[]" 
    elseif myreturn = "ArrayDouble*" then 
      myreturn ="Double[]"      
    elseif myreturn = "B4RString*" then 
      myreturn ="B4R::B4RString*" 
    end if
    xml_returnmod = myreturn
   end function 
  
  '==============================================' 
  ' B4Rlibrary - [cpp creation] -rename duplicated subs
  '==============================================' 
function cpp_rename_dup(svcmd,allcmd)
   dim i , loccmd
   loccmd= svcmd
   for i = 1 to 9
     if instr(allcmd,loccmd+"-") > 0 then  'command duplicated'
        loccmd = svcmd+cstr(i)
     else
       cpp_rename_dup = loccmd
       i = 10
     end if
    next
 end function    
          
  '==============================================' 
  ' B4Rlibrary - [cpp creation] - global replace
  'replace parameters not managed by B4R by parameters known by B4R
  'remove parameters not used by B4R 
  '=============================================='     
sub cpp_replace
   mychaine = replace(mychaine,";","")
''   mychaine = replace(mychaine,"{","") 
''   mychaine = replace(mychaine,"}","")
   mychaine = replace(mychaine,"const ","")
   mychaine = replace(mychaine,"static ","")
   mychaine = replace(mychaine,"inline ","")
   mychaine = replace(mychaine,"unsigned ","u")   
   mychaine = replace(mychaine,"VIRTUAL ","")  
   mychaine = replace(mychaine,"virtual ","")  
   mychaine = replace(mychaine,"typedef ","")
   mychaine = replace(mychaine,"volatile ","") 
   
   mychaine = replace(mychaine,"uchar ","char ")      
   mychaine = replace(mychaine,"boolean ","bool ")
   mychaine = replace(mychaine,"int8_t ","byte ")   
   mychaine = replace(mychaine,"uint8_t ","byte ") 
   mychaine = replace(mychaine,"ubyte ","byte ") 
   mychaine = replace(mychaine,"int ","int16_t ")       
   mychaine = replace(mychaine,"short ","int16_t ") 
   mychaine = replace(mychaine,"uint ","uint16_t ")     
   mychaine = replace(mychaine,"size_t ","uint16_t ")
   mychaine = replace(mychaine,"word ","uint16_t ") 
   mychaine = replace(mychaine,"long ","int32_t ")     
   mychaine = replace(mychaine,"ulong ","uint32_t ")

''   mychaine = replace(mychaine,"float","double")
   mychaine = replace(mychaine,"constexpr ","")
   mychaine = replace(mychaine,"__attribute__((deprecated))","")
''   mychaine = replace(mychaine,"
end sub

 

  '==============================================' 
  ' B4Rlibrary - [ccp creation] - sort/adapt RETURN values to B4R
  ' list of RETURN for library with EVENT / without EVENT'
  '==============================================' 
function sortreturn(myline,ver)
         dim linetype1,linetype2,linetypeAV
           
        if left(myline,8)= "double *" then
           myline = trim(mid(myline,9))
           linetype2 = "ArrayDouble*" 
           linetype1 = "??double*" 
           linetypeAV = "double *"  
           
        elseif left(myline,7)= "float *" then
           myline = trim(mid(myline,8))
           linetype2 = "ArrayDouble*" 
           linetype1 = "??float *" 
           linetypeAV = "float *"  
                    
        elseif left(myline,10)= "uint32_t *" then
           myline = trim(mid(myline,11)) 
           linetype2 = "ArrayULong*"
           linetype1 = "??uint32_t *"
           linetypeAV = "uint32_t *"
 
        elseif left(myline,9)= "int32_t *" then
           myline = trim(mid(myline,10))
           linetype2 = "ArrayLong*"
           linetype1 = "??int32_t *"
           linetypeAV = "int32_t *"
           
        elseif left(myline,10)= "uint16_t *" then
           myline = trim(mid(myline,11))
           linetype2 = "ArrayUInt*"
           linetype1 = "??uint16_t*"
           linetypeAV = "uint16_t *"
                          
        elseif left(myline,9)= "int16_t *" then
           myline = trim(mid(myline,10))
           linetype2 = "ArrayInt*"  
           linetype1 = "??int16_t*"
           linetypeAV = "int16_t *" 
    
        elseif left(myline,6)= "byte *" then
           myline = trim(mid(myline,7))
           linetype2 = "ArrayByte*"
           linetype1 = "??byte*"
           linetypeAV = "byte *"
           
        elseif left(myline,6)= "char *" then
            myline = trim(mid(myline,7))
            linetype2 = "B4RString*"
            linetype1 = "??char*"   
            linetypeAV = "char *"        
            
        elseif left(myline,6)= "String" then
            myline = trim(mid(myline,7))
            linetype2 = "B4RString*"
            linetype1 = "??String"   
            linetypeAV = "String" 
            
        elseif left(myline,6)= "stream" then
            myline = trim(mid(myline,7))
            linetype2 = "B4RStream*" 
            linetype1 = "??stream*"     
            linetypeAV = "stream"                  

        elseif left(myline,9)= "IPAddress" then
            myline = trim(mid(myline,10))
            linetype2 = "B4RString*"
            linetype1 = "??IPAddress"   
            linetypeAV = "IPAddress" 
           
        elseif left(myline,6)= "double" then
           myline = trim(mid(myline,7))
           linetype2 = "double" 
           linetype1 = "double" 
           linetypeAV = "double"  
           
        elseif left(myline,5)= "float" then
           myline = trim(mid(myline,6))
           linetype2 = "float" 
           linetype1 = "float" 
           linetypeAV = "float"  
           
        elseif left(myline,8)= "uint32_t" then
           myline = trim(mid(myline,9)) 
           linetype2 = "uint32_t"
           linetype1 = "uint32_t"           
           linetypeAV = "uint32_t"
           
        elseif left(myline,7)= "int32_t" then
           myline = trim(mid(myline,8)) 
           linetype2 = "int32_t"
           linetype1 = "int32_t"           
           linetypeAV = "int32_t"
           
        elseif left(myline,8)= "uint16_t" then
           myline = trim(mid(myline,9))
           linetype2 = "uint16_t"  
           linetype1 = "uint16_t"             
           linetypeAV = "uint16_t"
           
       elseif left(myline,7)= "int16_t" then
           myline = trim(mid(myline,8))
           linetype2 = "int16_t" 
           linetype1 = "int16_t"             
           linetypeAV = "int16_t"
           
        elseif left(myline,4)= "byte" then
           myline = trim(mid(myline,5))
           linetype2 = "byte"
           linetype1 = "byte"           
           linetypeAV = "byte"
           
         elseif left(myline,4)= "char" then
            myline = trim(mid(myline,5))
            linetype2 = "byte"
            linetype1 = "byte"              
            linetypeAV = "char"             
              
        elseif left(myline,4)= "bool" then
           myline = trim(mid(myline,5)) 
           linetype2 = "bool"
           linetype1 = "bool"           
           linetypeAV = "bool"

        elseif left(myline,4)= "void"  then
           myline = trim(mid(myline,5))
           linetype2 = "void"
           linetype1 = "void"           
           linetypeAV = "void"
           
        end if
''        logaddline(linetype2)
''        logaddline(linetypeAV)      
        if ver = 1 then 
           sortreturn = linetype1+"|"+linetypeAV           'case without EVENT'
        else 
            sortreturn = linetype2+"|"+linetypeAV            'case with EVEN'
        end if      
end function

 '==============================================' 
 'B4Rlibrary - [ccp creation] - sort and adapt each parameter to B4R
 '==============================================' 
 sub sortpara 
    dim  l_p1,l_p2 ,i 
    svpar1 = split(svpara,",")
    svpar2 = split(svpara,",")    
    l_max2 = ubound(svpar1)  
 ''     logaddline(l_max2) 
    for i = 0 to l_max2
''    logaddline(svpar1(i) )   
              
       if instr(svpar1(i),"=") > 0 then 
           svpar1(i) = left(svpar1(i),instr(svpar1(i),"=")-1)
           svpar2(i) = svpar1(i)
       end if 
       svpar1(i) = trim(svpar1(i)) :     svpar2(i) = svpar1(i) 
      
       if  left(svpar1(i),8)= "double *"  then 
          svpar1(i) = replace(svpar1(i),"double *","ArrayDouble*")
          svpar2(i) = "(double*)"+trim(mid(svpar2(i),9))+"->data" '," + trim(mid(svpar2(i),9)) +"->length"  
          
       elseif  left(svpar1(i),7)= "float *"  then 
          svpar1(i) = replace(svpar1(i),"float *","ArrayDouble*")
          svpar2(i) = "(float*)"+trim(mid(svpar2(i),8))+"->data" '," + trim(mid(svpar2(i),9)) +"->length"      
                                                                                                                                                                   
       elseif  left(svpar1(i),10)= "uint32_t *"  then 
          svpar1(i) = replace(svpar1(i),"uint32_t *","ArrayULong*") 
          svpar2(i) = "(uint32_t*)"+trim(mid(svpar2(i),11))+"->data" '," + trim(mid(svpar2(i),8)) +"->length"  
          
       elseif  left(svpar1(i),9)= "int32_t *"  then 
          svpar1(i) = replace(svpar1(i),"int32_t *","ArrayLong*") 
          svpar2(i) = "(int32_t*)"+trim(mid(svpar2(i),10))+"->data" '," + trim(mid(svpar2(i),7)) +"->length" 
                               
       elseif  left(svpar1(i),10)= "uint16_t *"  then 
          svpar1(i) = replace(svpar1(i),"uint16_t *","ArrayUInt*") 
          svpar2(i) = "(uint16_t*)"+trim(mid(svpar2(i),11))+"->data" '," + trim(mid(svpar2(i),7)) +"->length"  
          
       elseif  left(svpar1(i),9)= "int16_t *"  then 
          svpar1(i) = replace(svpar1(i),"int16_t *","ArrayInt*") 
          svpar2(i) = "(int16_t*)"+trim(mid(svpar2(i),10))+"->data" '," + trim(mid(svpar2(i),6)) +"->length"  
                            
       elseif  left(svpar1(i),6)= "byte *"  then 
          svpar1(i) = replace(svpar1(i),"byte *","ArrayByte*") 
          svpar2(i) = "(byte*)"+trim(mid(svpar2(i),7))+"->data" '," + trim(mid(svpar2(i),8)) +"->length"  
            
       elseif  left(svpar1(i),6)= "char *"  then 
          svpar1(i) = replace(svpar1(i),"char *","B4RString*") 
          svpar2(i) = trim(mid(svpar2(i),7))+"->data" 
          
       elseif  left(svpar1(i),6)= "String"  then 
          svpar1(i) = replace(svpar1(i),"String","B4RString*") 
          svpar2(i) = trim(mid(svpar2(i),7))+"->data"    
          
       elseif  left(svpar1(i),9)= "IPAddress"  then 
          svpar1(i) = replace(svpar1(i),"IPAddress","ArrayByte*") 
          svpar2(i) = "(Byte*)"+trim(mid(svpar2(i),10))+"->data"                             
                    
       elseif  left(svpar1(i),6)= "double"  then 
          svpar2(i) = trim(mid(svpar2(i),7))

       elseif  left(svpar1(i),5)= "float"  then 
'          svpar1(i) = replace(svpar1(i),"float","double") 
          svpar2(i) = trim(mid(svpar2(i),6))   
          
       elseif  left(svpar1(i),8)= "uint32_t"  then 
          svpar2(i) = trim(mid(svpar2(i),9))
          
       elseif  left(svpar1(i),7)= "int32_t"  then 
          svpar2(i) = trim(mid(svpar2(i),8))   
                    
       elseif  left(svpar1(i),8)= "uint16_t"  then 
          svpar2(i) = trim(mid(svpar2(i),9))
          
       elseif  left(svpar1(i),7)= "int16_t"  then 
         svpar2(i) = trim(mid(svpar2(i),8)) 
                                                           
       elseif  left(svpar1(i),4)= "byte"  then 
          svpar2(i) = trim(mid(svpar2(i),5))
          
       elseif  left(svpar1(i),4)= "char"  then 
          svpar1(i) = replace(svpar1(i),"char","byte") 
          svpar2(i) = trim(mid(svpar2(i),5))
                    
       elseif  left(svpar1(i),4)= "bool"  then 
          svpar2(i) = trim(mid(svpar2(i),5))  
          
       elseif  left(svpar1(i),4)= "void"  then  
          svpar1(i) = replace(svpar1(i),"void","") 
          svpar2(i) = trim(mid(svpar2(i),5))
            
       else
          svpar1(i) = "?? "+ svpar1(i) 
          svpar2(i) = "?? "+ svpar2(i)    
       end if
     next  
end sub  

 '==============================================' 
 'B4Rlibrary - [ccp creation] - sort and adapt each parameter to B4R
 '==============================================' 
function adaptpara(para, vers) 
    dim  i ,l_max ,svpar
 ''   svpar = replace(svpar," *","*")
    svpar = split(para,",") 
    if vers <> 2 then vers = 1
    l_max = ubound(svpar) 
    if vers <> "1" and vers <> "2" then vers = "1"
 ''     logaddline(l_max2) 
    svpar1 = svpar
    svpar2 = svpar 
    for i = 0 to l_max
''    logaddline(svpar(i) )         
       if instr(svpar(i),"=") > 0 then 
           svpar1(i) = trim(left(svpar(i),instr(svpar(i),"=")-1))
       else
           svpar1(i) = trim(svpar(i))    
       end if 
       svpar2(i) = svpar1(i)
      
       if  left(svpar1(i),8)= "double *"  then 
          svpar1(i) = replace(svpar1(i),"double *","ArrayDouble*")
          svpar2(i) = "(double*)"+trim(mid(svpar2(i),9))+"->data" '," + trim(mid(svpar2(i),9)) +"->length"  
                                                                                                                                                                   
       elseif  left(svpar1(i),10)= "uint32_t *"  then 
          svpar1(i) = replace(svpar1(i),"uint32_t *","ArrayULong*") 
          svpar2(i) = "(uint32_t*)"+trim(mid(svpar2(i),11))+"->data" '," + trim(mid(svpar2(i),8)) +"->length"  
          
       elseif  left(svpar1(i),9)= "int32_t *"  then 
          svpar1(i) = replace(svpar1(i),"int32_t *","Arraylong*") 
          svpar2(i) = "(int32_t*)"+trim(mid(svpar2(i),10))+"->data" '," + trim(mid(svpar2(i),7)) +"->length" 
                               
       elseif  left(svpar1(i),10)= "uint16_t *"  then 
          svpar1(i) = replace(svpar1(i),"uint16_t *","ArrayUInt*") 
          svpar2(i) = "(uint16_t*)"+trim(mid(svpar2(i),11))+"->data" '," + trim(mid(svpar2(i),7)) +"->length"  
          
       elseif  left(svpar1(i),9)= "int16_t *"  then 
          svpar1(i) = replace(svpar1(i),"int16_t *","ArrayInt*") 
          svpar2(i) = "(int16_t*)"+trim(mid(svpar2(i),10))+"->data" '," + trim(mid(svpar2(i),6)) +"->length"  
                            
       elseif  left(svpar1(i),6)= "byte *"  then 
          svpar1(i) = replace(svpar1(i),"byte *","ArrayByte*") 
          svpar2(i) = "(byte*)"+trim(mid(svpar2(i),7))+"->data" '," + trim(mid(svpar2(i),8)) +"->length"  
            
       elseif  left(svpar1(i),6)= "char *"  then 
          svpar1(i) = replace(svpar1(i),"char *","B4RString*") 
          svpar2(i) = trim(mid(svpar2(i),7))+"->data" 
                    
       elseif  left(svpar1(i),6)= "double"  then 
          svpar2(i) = trim(mid(svpar2(i),7))
          
       elseif  left(svpar1(i),8)= "uint32_t"  then 
          svpar2(i) = trim(mid(svpar2(i),9))
          
       elseif  left(svpar1(i),7)= "int32_t"  then 
          svpar2(i) = trim(mid(svpar2(i),8))   
                    
       elseif  left(svpar1(i),8)= "uint16_t"  then 
          svpar2(i) = trim(mid(svpar2(i),9))
          
       elseif  left(svpar1(i),7)= "int16_t"  then 
         svpar2(i) = trim(mid(svpar2(i),8)) 
                                                           
       elseif  left(svpar1(i),4)= "byte"  then 
          svpar2(i) = trim(mid(svpar2(i),5))
          
       elseif  left(svpar1(i),4)= "char"  then 
          svpar1(i) = replace(svpar1(i),"char","byte") 
          svpar2(i) = trim(mid(svpar2(i),5))
                    
       elseif  left(svpar1(i),4)= "bool"  then 
          svpar2(i) = trim(mid(svpar2(i),5))  
          
       elseif  left(svpar1(i),4)= "void"  then  
          svpar1(i) = replace(svpar1(i),"void","") 
          svpar2(i) = trim(mid(svpar2(i),5))
            
       else
          svpar1(i) = "?? "+ svpar1(i) 
          svpar2(i) = "?? "+ svpar2(i)    
       end if
 ''         logaddline("==============>"+svpar1(i) )  
     next
     if vers = 1 then   
       adaptpara = join(svpar1,",")
 ''      logaddline("=======>"+ join(svpar1,",") )
     else 
       adaptpara = join(svpar2,", ") 
    end if    
end function


 '==============================================' 
 'B4Rlibrary - [ccp creation] - sort and adapt parameters for callback functions
 '==============================================' 
function adaptcbk(pname,ptype,nbsp)
    dim pname2, ptype2
    if ptype = "char *" then
      pname2 = "str"+pname
      mychaine = mychaine +space(nbsp)+"B4RString* "+pname2+" = CreateStackMemoryObject(B4RString);"+chr(10)
      mychaine = mychaine +space(nbsp)+pname2+"->data = "+pname+";"+chr(10)
      adaptcbk = pname2
      
    elseif ptype = "byte *"  then
    pname2 ="arr"+pname
      mychaine = mychaine +space(nbsp)+"ArrayByte* "+pname2+" = CreateStackMemoryObject(ArrayByte);"+chr(10)    
      mychaine = mychaine +space(nbsp)+pname2+"->data = "+pname+";" +chr(10)
      mychaine = mychaine +space(nbsp)+pname2+"->length = ??length;"+chr(10)
      adaptcbk = pname2 
    elseif instr(ptype,"*")> 0 then
       adaptcbk = "??"+pname2
    else
       adaptcbk = pname   
    end if    
end function


 '==============================================' 
 'B4Rlibrary - [ccp/h creation] - sort each parameter provided by operator
 '==============================================' 
function confinit
   dim  mytemp ,mytemp_max, mytmp, i ' mytmp1, mytmp2, mytmp3 
   dim myline  
   myinitP="":myinitB="" :myinitincludeP="" :myinitincludeB="" :myloopI="":myloopB="":myloopP="":myloopConf1="":myeventB1="":myeventP1="":myloopConf2="":myeventB2="":myeventP2="":myloopConf3="":myeventB3="":myeventP3=""
   mycbkB1="":mycbkP1="":mycbkConf1="":mycbkB2="":mycbkP2="":mycbkConf2="" :mycbkB3="":mycbkP3="":mycbkConf3=""  :confinit = true
   private0="???? ????":private1="???? ????":private2="???? ????":private3="???? ????"
   myline = trim(myarray(0))
   if left(myline,16)= "//#new(backend):" then
     mybackend = trim(mid(myline,17,instr(myline,"//-")-17))  
     if (mybackend = "")or(mybackend<>"Y") then mybackend = "N"
   end if

   myline = trim(myarray(1))
   if left(myline,13)= "//#Init_Base:" then
     mytemp = trim(mid(myline,14,instr(myline,"//-")-14))
     if instr(mytemp,"(") > 0 then 
       myinitB = trim(mid(mytemp,1,instr(mytemp,"(")-1))
       mytemp = trim(mid(mytemp,instr(mytemp,"(")+1))
       myinitP = trim(mid(mytemp,1,instr(mytemp,")")-1)) 
     end if  
   end if        
   logaddline("myinitB+myinitP=<"+myinitB + " | " + myinitP +">")  
   
   myline = trim(myarray(2))   
   if left(myline,16)= "//#Init_Include:" then
     mytemp = trim(mid(myline,17,instr(myline,"//-")-17))  
     if instr(mytemp,"(") > 0 then
       myinitincludeB = trim(mid(mytemp,1,instr(mytemp,"(")-1))
       mytemp = trim(mid(mytemp,instr(mytemp,"(")+1))
       myinitincludeP = trim(mid(mytemp,1,instr(mytemp,")")-1))
     end if           
   end if     
   logaddline("myinitincludeB+myinitincludeP=<"+myinitincludeB + " | " + myinitincludeP +">")  
   
   myline = trim(myarray(3))
   if left(myline,13)= "//#Loop_Base:" then
     mytemp = trim(mid(myline,14,instr(myline,"//-")-14))
     if instr(mytemp,"(") > 0 then
       myloopB = trim(mid(mytemp,1,instr(mytemp,"(")-1))
       mytemp = trim(mid(mytemp,instr(mytemp,"(")+1))
       myloopP = trim(mid(mytemp,1,instr(mytemp,")")-1))
     end if  
   end if 
   logaddline("myloopB+myloopP=<"+myloopB+" | " + myloopP +">")   

   myline = trim(myarray(4))
   if left(myline,15)= "//#Loop1_Event:" then
     mytemp = trim(mid(myline,16,instr(myline,"//-")-16))
     if instr(mytemp,"(") > 0 then
       myeventB1 = trim(mid(mytemp,1,instr(mytemp,"(")-1))
       mytemp = trim(mid(mytemp,instr(mytemp,"(")+1))
       myeventP1 = trim(mid(mytemp,1,instr(mytemp,")")-1))
       if myeventB1 <> "" then private0 = "::looper("       ' needed to add looper in private part un h fiile'
     end if  
   end if   

   if (myinitincludeB = myloopB) and myeventB1 <> "" then  myloopI = "Y" '(case same function loop_base = init_include)  if myloopB = "" and myeventB1 <> "" then myloopI = "Y"
   if myloopB = "" and myeventB1 <> "" then myloopI = "Y"
   'added for car loop included at initialize()'
   logaddline("myloopI= <"+myloopI+">") 
   logaddline("myeventB1+myeventP1=<"+myeventB1+" | "+myeventP1+">") 
''   logaddline("private0="+private0)  
   
   myline = trim(myarray(5))
   if left(myline,16)= "//#Loop1_Config:" then  myloopConf1 = trim(mid(myline,17,instr(myline,"//-")-17))
   if myloopConf1 = "" then myloopConf1 = "???? ????"
   logaddline("myloopConf1=<"+myloopConf1+">")  
           
   myline = trim(myarray(6))
   if left(myline,15)= "//#Loop2_Event:" then
     mytemp = trim(mid(myline,16,instr(myline,"//-")-16))
     if instr(mytemp,"(") > 0 then
       myeventB2 = trim(mid(mytemp,1,instr(mytemp,"(")-1))
       mytemp = trim(mid(mytemp,instr(mytemp,"(")+1))
       myeventP2 = trim(mid(mytemp,1,instr(mytemp,")")-1))
     end if  
   end if   
   logaddline("myeventB2+myeventP2=<"+myeventB2+" | "+myeventP2+">")       

   myline = trim(myarray(7))
   if left(myline,16)= "//#Loop2_Config:" then  myloopConf2 = trim(mid(myline,17,instr(myline,"//-")-17))
   if myloopConf2 = "" then myloopConf2 = "???? ????"
   logaddline("myloopConf2=<"+myloopConf2+">")  
        
   myline = trim(myarray(8))
   if left(myline,15)= "//#Loop3_Event:" then
     mytemp = trim(mid(myline,16,instr(myline,"//-")-16))
     if instr(mytemp,"(") > 0 then
       myeventB3 = trim(mid(mytemp,1,instr(mytemp,"(")-1))
       mytemp = trim(mid(mytemp,instr(mytemp,"(")+1))
       myeventP3 = trim(mid(mytemp,1,instr(mytemp,")")-1))
     end if  
   end if   
   logaddline("myeventB3+myeventP3=<"+myeventB3+" | "+myeventP3+">")       
   myline = trim(myarray(9))
   if left(myline,16)= "//#Loop3_Config:" then  myloopConf3 = trim(mid(myline,17,instr(myline,"//-")-17))
   if myloopConf3 = "" then myloopConf3 = "???? ????"
   logaddline("myloopConf3=<"+myloopConf3+">")  
      
   myline = trim(myarray(10))   
   if left(myline,18)= "//#CallBack1_Base:" then
     mytemp = trim(mid(myline,19,instr(myline,"//-")-19))
     if instr(mytemp,"(") > 0 then 
        mycbkB1 = trim(mid(mytemp,1,instr(mytemp,"(")-1))
        mytemp = trim(mid(mytemp,instr(mytemp,"(")+1))
        mycbkP1 = trim(mid(mytemp,1,instr(mytemp,")")-1))
        private1 = "::"+trim(mid(mycbkB1,instrrev(mycbkB1," "))) +"(" ': if private1 ="" then private1 = "???? ????"  
     end if   
   end if    
   logaddline("mycbkB1+mycbkP1=<"+mycbkB1+" | "+mycbkP1+">"+ private1)  
''   logaddline("private1="+private1) 
      
   myline = trim(myarray(11))
   if left(myline,20)= "//#CallBack1_Config:" then mycbkConf1 = trim(mid(myline,21,instr(myline,"//-")-21))
   if  mycbkConf1 = "" then  mycbkConf1 = "???? ????"
   logaddline("mycbk1Conf=<"+mycbkConf1+">")  
      
   myline = trim(myarray(12))
   if left(myline,18)= "//#CallBack2_Base:" then
     mytemp = trim(mid(myline,19,instr(myline,"//-")-19)) 
     if instr(mytemp,"(") > 0 then 
       mycbkB2 = trim(mid(mytemp,1,instr(mytemp,"(")-1))
       mytemp = trim(mid(mytemp,instr(mytemp,"(")+1))
       mycbkP2 = trim(mid(mytemp,1,instr(mytemp,")")-1))
       private2 = "::"+trim(mid(mycbkB2,instrrev(mycbkB2," ")))+"(" ': if private2 ="" then private2 = "???? ????"
     end if  
   end if 
   logaddline("mycbkB2+mycbkP2=<"+mycbkB2+" | "+mycbkP2+">")  
''   logaddline("private2="+private2) 
    
   myline = trim(myarray(13))
   if left(myline,20)= "//#CallBack2_Config:" then mycbkConf2 = trim(mid(myline,21,instr(myline,"//-")-21))
   if  mycbkConf2 = "" then  mycbkConf2 = "???? ????"
   logaddline("mycbk2Conf=<"+mycbkConf2+">")  

      myline = trim(myarray(14))
   if left(myline,18)= "//#CallBack3_Base:" then
     mytemp = trim(mid(myline,19,instr(myline,"//-")-19)) 
     if instr(mytemp,"(") > 0 then 
       mycbkB3 = trim(mid(mytemp,1,instr(mytemp,"(")-1))
       mytemp = trim(mid(mytemp,instr(mytemp,"(")+1))
       mycbkP3 = trim(mid(mytemp,1,instr(mytemp,")")-1))
       private3 = "::"+trim(mid(mycbkB3,instrrev(mycbkB3," ")))+"(" ': if private3 ="" then private3 = "???? ????"
     end if  
   end if 
   logaddline("mycbkB3+mycbkP3=<"+mycbkB3+" | "+mycbkP3+">")  
''   logaddline("private3="+private3)
        
   myline = trim(myarray(15))
   if left(myline,20)= "//#CallBack3_Config:" then mycbkConf3 = trim(mid(myline,21,instr(myline,"//-")-21))
   if  mycbkConf3 = "" then  mycbkConf3 = "???? ????"
   logaddline("mycbk3Conf=<"+mycbkConf3+">")  

   '-------------------------------------'
   'check of loop and callback parameters
   '-------------------------------------'
   if  myinitB ="" and  mybackend ="Y" then
      logaddline( "Init_Base parameter mandatory for libray launch")
      confinit = false   
   elseif myloopI = "Y" and ( myloopConf1 = "" or myeventB1 = "") then
      logaddline( "INIT with loop =>  if Loop_Base=Y, Loop_Config1 and Loop_Event1 are mandatories")
      confinit = false
   elseif myloopB <> "" and (myloopConf1 ="" or myeventB1="") then  
      logaddline( "LOOP configuration issue: with Loop_Base, Loop_Config1 and Loop_Event1 are mandatory")
      confinit = false 
   elseif myeventB1 = "" and (myeventB2 <> "" or myeventB3 <> "") then  
      logaddline( "LOOP configuration issue: Event_Base1 mandatory before Event_Base2 usage")
      confinit = false      
   elseif myloopConf2 = "" and myeventB2 <> "" then  
      logaddline( "LOOP configuration issue: Event_Conf2 is mandatory with Event_Base2 usage")
      confinit = false     
   elseif myloopConf1 = "" and myeventB1 <> "" then  
      logaddline( "LOOP configuration issue: Event_Conf1 is mandatory with Event_Base1 usage")
      confinit = false 
   elseif myloopConf3 = "" and myeventB3 <> "" then  
      logaddline( "LOOP configuration issue: Event_Conf3 is mandatory with Event_Base1 usage")
      confinit = false 
                         
   elseif mycbkB1 <> "" and mycbkConf1 =""  then  
      logaddline( "CallBack1 configuration issue: with CallBack1_Base, CallBack1_Config is mandatory")
      confinit = false    
   elseif mycbkB2 <> "" and mycbkConf2 =""  then  
      logaddline( "CallBack2 configuration issue: with CallBack2_Base, CallBack2_Config is mandatory")
      confinit = false
   elseif mycbkB3 <> "" and mycbkConf3 =""  then  
      logaddline( "CallBack3 configuration issue: with CallBack3_Base, CallBack3_Config is mandatory")
      confinit = false
   end if                                                                                                             
   
  'check of parameter number in loop config and callback config with nb of parameters in loop Event an callback Base'  
  if myeventB1 <> "" then if not(confcheck(myeventP1,myloopConf1)) then confinit = false  
  if myeventB2 <> "" then if not(confcheck(myeventP2,myloopConf2)) then confinit = false   
  if myeventB3 <> "" then if not(confcheck(myeventP3,myloopConf3)) then confinit = false   
  if mycbkB1 <> "" then if not(confcheck(mycbkP1,mycbkConf1)) then confinit = false    
  if mycbkB2 <> "" then  if not(confcheck(mycbkP2,mycbkConf2)) then confinit = false   
  if mycbkB3 <> "" then  if not(confcheck(mycbkP3,mycbkConf3)) then confinit = false 

  'check if typedef are different for callback and loop created
   if not(typedefcheck) then confinit = false 
  'check if B4R sub are different for loop and callcbk created'
   if not(B4Rsubcheck) then confinit = false  
         
   if confinit = false then mytemp= msgbox("Error in config parameters"+chr(10)+"more information in LogFile",16)
 end function
'**************************************************'
'check of B4Rsub different on each loop and callcbk
function B4Rsubcheck
'**************************************************'
  dim typedef,mytyp(6),mybase(6),tmp,tmp1,i,j,x
  B4Rsubcheck = true : i = 0
  x = array(myloopConf1, myloopConf2, myloopConf3, mycbkConf1, mycbkConf2, mycbkConf3) 
  for each tmp in x
     tmp1 =  wordsplit(tmp)
     mytyp(i) = tmp1(ubound(tmp1))
     i = i +1  
  next
  i=0
  x = array(myeventB1, myeventB2, myeventB3, mycbkB1, mycbkB2, mycbkB3) 
  for each tmp in x
     if tmp <> "" then mybase(i) = 1 else mybase(i) = 0
     i = i+1  
  next  
  
  for i = 0 to 5
    if mybase(i) = 0 then exit for
    for j = i+1 to 5
       if mybase(j) = 0 then exit for
''       logaddline(mytyp(i)+" "+mytyp(j))
       if mytyp(i) = mytyp(j) then           
          B4Rsubcheck = false
          logaddline(" ["+mytyp(i)+"] -same B4Rsub in 2 configs")
       end if   
     next
  next   
end function 
'***************************************************'  
'check of typedef different on each loop and callcbk
function typedefcheck
'***************************************************'
  dim typedef,mytyp(6),mybase(6),tmp,tmp1,i,j,x
  typedefcheck = true : i = 0
  x = array(myloopConf1, myloopConf2, myloopConf3, mycbkConf1, mycbkConf2, mycbkConf3) 
  for each tmp in x
     tmp1 =  wordsplit(tmp)
     mytyp(i) = tmp1(0)
     i = i +1  
  next
  i=0
  x = array(myeventB1, myeventB2, myeventB3, mycbkB1, mycbkB2, mycbkB3) 
  for each tmp in x
     if tmp <> "" then mybase(i) = 1 else mybase(i) = 0
     i = i+1  
  next    
  for i = 0 to 5
    if mybase(i) = 0 then exit for
    for j = i+1 to 5
       if mybase(j) = 0 then exit for
''       logaddline(mytyp(i)+" "+mytyp(j))
       if mytyp(i) = mytyp(j) then           
          typedefcheck = false
          logaddline(" ["+mytyp(i)+"] -same typedef in 2 configs")
       end if   
     next
  next   
end function  
'**************************************************'  
'check of parameters in loop conf and callcbk conf 
 function confcheck(para,conf)
'**************************************************'
   dim i,mytemp, mytemp_max ,mytmp
   confcheck = true
   if para <> "" and para <> "void" then
     mytemp = split(para,",")
     mytemp_max=ubound(mytemp) ' nbr of parameters'
   else
     mytemp_max = -1
   end if      
   mytmp = wordsplit(Conf)
   for i = 1 to ubound(mytmp)-1 
''     logaddline("["+cstr(mytmp(i))+"] - ["+cstr(mytemp_max)+"]")  
     if cint(mytmp(i)) > cint(mytemp_max) then 
       logaddline("para-"+cstr(i) +" ["+para+"]  ["+conf+"] parameter out of range")
       confcheck = false
     end if    
   next   
 end function 

 '==============================================' 
 'B4Rlibrary - [h creation] - add //~ Event:
 '==============================================' 
function createvent(conf,P)
  dim i, mytemp, mytemp_max, mytemp1,mytmp, mytmp1  
  logaddline("conf="+conf+ " P="+P+">")
  if P = "" then P = "void"
  mytemp = wordsplit(conf): mytemp_max = ubound(mytemp)
  logaddline(mytemp(mytemp_max))
  mytemp1 = "    //~Event: "+ mid(mytemp(mytemp_max),1,len(mytemp(mytemp_max))-3) +"("
  mytmp = split(P,",")
  for i = 1 to mytemp_max -1
    if mytemp(i) = "-1" then exit for
    mytmp1 = trim(mytmp(mytemp(i)))
    if instr(mytmp1,"void") = 1 then 
       mytmp1= ""
    elseif instr(mytmp1,"char *") = 1 then
      mytmp1 = trim(mid(mytmp1,7))+" As String"
    elseif instr(mytmp1,"byte *") = 1 then
      mytmp1 = trim(mid(mytmp1,7))+"() As Byte"
    elseif instr(mytmp1,"*") > 0 then
      mytmp1 = "??"+mytmp1
    else
''     logaddline(cstr(i)+" "+mytmp1)
      mytmp1 = trim(mid(mytmp1,instrrev(mytmp1," ")))+" As "  + trim(mid(mytmp1,1, instrrev(mytmp1," ")-1))  
    end if
    if i = 1 then mytemp1 = mytemp1 + mytmp1 else  mytemp1 = mytemp1 + ", "+ mytmp1
  next 
  createvent = mytemp1 + ")"
end function


 '==============================================' 
 'B4Rlibrary - [h creation] - add subvoid in Private
 '==============================================' 
function creatsubvoid(conf)
  dim i, mytemp, mytemp_max', mytemp1,mytmp, mytmp1  
''  logaddline("conf="+conf+ " P="+P+">")
  mytemp = wordsplit(conf): mytemp_max = ubound(mytemp)
''  logaddline(mytemp(mytemp_max))
  creatsubvoid = "            "+ mytemp(0)+" "+mytemp(mytemp_max)+";"
end function


 '==============================================' 
 'B4Rlibrary - [h creation] - add typedef 
 '==============================================' 
function creattypedef(conf,P)
  dim i, mytemp, mytemp_max, mytemp1,mytmp, mytmp1  
''  logaddline("conf="+conf+ " P="+P+">")
  mytemp = wordsplit(conf): mytemp_max = ubound(mytemp)
''  logaddline(mytemp(mytemp_max))
  mytemp1 = "    typedef void (*"+ trim(mytemp(0)) +")("
  mytmp = split(P,",")
  for i = 1 to mytemp_max -1
    if mytemp(i) = "-1" then exit for
    mytmp1 = trim(mytmp(mytemp(i)))
    if instr(mytmp1,"void") = 1 then 
       mytmp1= "void"
    elseif instr(mytmp1,"char *") = 1 then
      mytmp1 = "B4RString* str"
    elseif instr(mytmp1,"byte *") = 1 then
      mytmp1 = "Array* barray"
    elseif instr(mytmp1,"*") > 0 then
      mytmp1 = "??"+mytmp1
    else
''     logaddline(cstr(i)+" "+mytmp1)
      mytmp1 = mytmp1    
    end if
    if i = 1 then mytemp1 = mytemp1 + mytmp1 else  mytemp1 = mytemp1 + ", "+ mytmp1
  next 
  logaddline("create_typedef="+mytemp1)
  if right(mytemp1,1) = "(" then creattypedef = mytemp1+"void);" else  creattypedef = mytemp1 + ");"
end function

 '==============================================' 
 'B4Rlibrary - [cpp creation] - add loop management
 '==============================================' 
function makeloop(myeventB,myeventP,myloopConf)
  dim mytemp, stack_flag, mytemp_max, mytmp, mytmp1, mytmp2, mytmp3 , i  
         mytemp = mid(myeventB,instr(myeventB," ")+1)
         mychaine = mychaine +"       if (me->rcs->"+mytemp+"("+adaptpara(myeventP,2) + ")) { " + CHR(10)
''         mytemp = wordsplit(myloopConf1) : mytemp_max = ubound(mytemp) 
         stack_flag = 0
         mytemp = wordsplit(myloopConf) : mytemp_max = ubound(mytemp)
         mytmp = split(myeventP,",") 
         for i = 1 to mytemp_max -1
           if mytemp(i) = "-1" then exit for
           mytmp2 = mytmp(mytemp(i)) : if instrrev(mytmp2," ")> 0 then mytmp2 = trim(mid(mytmp2,1,instrrev(mytmp2," ")))                  'type para    
           if instr(mytmp2,"char *")>0 or  instr(mytmp2,"byte *")>0 then stack_flag = 1 
         next        
         if stack_flag = 1 then mychaine = mychaine +"         const uint16_t cp = B4R::StackMemory::cp;"+chr(10)  
         for i = 1 to mytemp_max -1
           if mytemp(i) = "-1" then exit for
           mytmp1 = mytmp(mytemp(i)) : if instrrev(mytmp1," ")> 0 then mytmp1 = trim(mid(mytmp1,instrrev(mytmp1," "))) else mytmp1 =""    'para name'
           mytmp2 = mytmp(mytemp(i)) : if instrrev(mytmp2," ")> 0 then mytmp2 = trim(mid(mytmp2,1,instrrev(mytmp2," ")))                  'type para
''         mychaine = mychaine +"    "+mytmp1+"///"+mytmp2+"///"+mytemp(i)+chr(10)  
           if mytmp3 = "" then mytmp3 = mytmp3 + adaptcbk(mytmp1,mytmp2,9) else  mytmp3 = mytmp3 +", "+ adaptcbk(mytmp1,mytmp2,9) 
         next   
         mytemp = wordsplit(myloopConf) : mytemp_max = ubound(mytemp)    
         mychaine = mychaine +"         me->"+ mytemp(mytemp_max) +"("+ +mytmp3+");"+chr(10)   
         if stack_flag = 1 then mychaine = mychaine +"         B4R::StackMemory::cp = cp;"+chr(10)          
         mychaine = mychaine +"         }" + chr(10)   
end function

 '==============================================' 
 'B4Rlibrary - [cpp creation] - add callback management
 '==============================================' 
function makecbk(mycbkB,mycbkP,mycbkConf)
  dim mytemp, stack_flag, mytemp_max, mytmp, mytmp1, mytmp2, mytmp3 , i  
         mytmp3 = ""
         mytemp = mid(mycbkB,1,instr(mycbkB," ")-1)
         mychaine = mychaine +"    "+mytemp+" "+B4Rname+"::"
         mytemp = mid(mycbkB,instr(mycbkB," ")+1)
         mychaine = mychaine +mytemp+"("+mycbkP+") " + chr(10)
         mychaine = mychaine +"    {" + chr(10)

         stack_flag = 0
         mytemp = wordsplit(mycbkConf) : mytemp_max = ubound(mytemp) 
         mytmp = split(mycbkP,",")
         for i = 1 to mytemp_max -1
           if mytemp(i) = "-1" then exit for
           mytmp2 = mytmp(mytemp(i)) : if instrrev(mytmp2," ")> 0 then mytmp2 = trim(mid(mytmp2,1,instrrev(mytmp2," ")))                  'type para    
           if instr(mytmp2,"char *")>0 or  instr(mytmp2,"byte *")>0 then stack_flag = 1 
         next        
         if stack_flag = 1 then mychaine = mychaine +"    const uint16_t cp = B4R::StackMemory::cp;"+chr(10) 
         for i = 1 to mytemp_max -1
           if mytemp(i) = "-1" then exit for
           mytmp1 = mytmp(mytemp(i)) : if instrrev(mytmp1," ")> 0 then mytmp1 = trim(mid(mytmp1,instrrev(mytmp1," "))) else mytmp1 =""    'para name'
           mytmp2 = mytmp(mytemp(i)) : if instrrev(mytmp2," ")> 0 then mytmp2 = trim(mid(mytmp2,1,instrrev(mytmp2," ")))                  'type para
           if mytmp3 = "" then mytmp3 = mytmp3 + adaptcbk(mytmp1,mytmp2,4) else  mytmp3 = mytmp3 +", "+ adaptcbk(mytmp1,mytmp2,4) 
         next  
         mytemp = wordsplit(mycbkConf) : mytemp_max = ubound(mytemp)    
         mychaine = mychaine +"    instance->"+ mytemp(mytemp_max) +"("+ +mytmp3+");"+chr(10)          
         if stack_flag = 1 then mychaine = mychaine +"    B4R::StackMemory::cp = cp;"+chr(10)          
         mychaine = mychaine +"    };" + chr(10)   
 end function
'-------------------------------------------------------
'  End script
'-------------------------------------------------------
  























'==============================================' 
'modifications to do from lines at end of xxx.h.clean file
'==============================================' 
sub mod_cleanfile
   dim linemax , i ,tosearch, toreplace,l_p1,l_p2,l_p3
 ''logClear
 
   myarray = split(mychaine,chr(10))
   linemax = ubound(myarray)
 '' msgbox linemax

   for i=0 to linemax
     if left(trim(myarray(i)),6) = "//## "+chr(34) then
       l_p1 =instr(myarray(i),"//## "+chr(34)) 
       l_p2 =instr(myarray(i),chr(34)+","+chr(34)) 
       l_p3 =instrRev(myarray(i),chr(34)) 
       if l_p1 > 0 then
          tosearch = mid(myarray(i),l_p1+6, l_p2-l_p1-6)
logaddline("<"+tosearch+">")
          toreplace = mid(myarray(i), l_p2+3,l_p3-l_p2-3)
logaddline("<"+toreplace+">")
          mychaine = replace(mychaine,tosearch, toreplace)
       end if   
     end if    
   next 
   myarray = split(mychaine,chr(10))
   linemax = ubound(myarray)
 '' msgbox linemax
   mychaine = ""
   for i=0 to linemax
     if left(trim(myarray(i)),4)="//##" then myarray(i)=""
     if myarray(i) <> "" then mychaine = mychaine +myarray(i) + chr(10)  
   next   
 end sub





'==============================================' 
'suppression of header used by script
'==============================================' 
 sub clean_header
   dim linemax , i 
 ''logClear
 
   set obj1 = NewEditor()           'new editor object
   obj1.assignActiveEditor         'assign PSPad window active to obj1
 
   mychaine = obj1.text
   mychaine = replace(mychaine,chr(13),"")
   myarray = split(mychaine,chr(10))
   linemax = ubound(myarray)
 '' msgbox linemax

   mychaine = ""
   for i=0 to linemax
     if left(trim(myarray(i)),2) <>"//" or left(trim(myarray(i)),3) ="//~"  then      
'//     if left(trim(myarray(i)),3)<>"//#" then
       mychaine = mychaine + myarray(i)+chr(10)
     end if    
   next   
   obj1.text(mychaine) 
 end sub

'==============================================' 
'suppression de toutes les lignes of comment
'==============================================' 
 sub clean_comments
   dim linemax , i 
 ''logClear
 
   set obj1 = NewEditor()           'new editor object
   obj1.assignActiveEditor         'assign PSPad window active to obj1
 
   mychaine = obj1.text
   mychaine = replace(mychaine,chr(13),"")
   myarray = split(mychaine,chr(10))
   linemax = ubound(myarray)
 '' msgbox linemax

   mychaine = ""
   for i=0 to linemax
        if left(trim(myarray(i)),2) <>"//" or left(trim(myarray(i)),3) ="//~" or left(trim(myarray(i)),3) ="//#" then     
          mychaine = mychaine + myarray(i)+chr(10)
     end if   
   next
   
   obj1.text(mychaine) 
 end sub


   
'==============================================' 
'fulltrim - multiple spaces removal
'==============================================' 
 Function fulltrim(Str)
    Dim WordArray, i
    WordArray = Split(Str)
    Str = ""
    For i = 0 To UBound(WordArray)
      If WordArray(i) <> "" Then Str = Str & WordArray(i) & " "
    Next
   fulltrim = Str
End Function

'==============================================' 
'split by word and return word nbr requested
'==============================================' 
 Function word(Str, Wnbr)
    Dim WordArray, i
    WordArray = Split(Str)
    Str = ""
    For i = 0 To UBound(WordArray)
      If WordArray(i) <> "" Then Str = Str & WordArray(i) & " "
    Next
    wordarray = split(Trim(Str)," ")
    if ubound(wordarray) <= Wnbr then
       word = wordarray(Wnbr) 
    else
       word = ""
    end if
End Function
         
'==============================================' 
'split by word after multiple spaces removal
'==============================================' 
 Function wordsplit(Str)
    Dim WordArray, i
    WordArray = Split(Str)
    Str = ""
    For i = 0 To UBound(WordArray)
      If WordArray(i) <> "" Then Str = Str & WordArray(i) & " "
    Next
    wordsplit = split(Trim(Str)," ")
End Function


'==============================================' 
'suppression de toutes les lignes contenant un text
'==============================================' 
 sub supp_line
   dim input  
 ''logClear
 
   set obj1 = NewEditor()           'new editor object
   set obj2 = NewEditor()           'new editor object       
   obj1.assignActiveEditor         'assign PSPad window active to obj1
   obj2.NewFile()                      'opens new file in PSPad and assign to obj2
 
   Input = InputBox("Suprression de toutes les lignes contenant le texte suivant")  
   mychaine = obj1.text
   mychaine = replace(mychaine,chr(10),"")
   myarray = split(mychaine,chr(13))
   linemax = ubound(myarray)
 '' msgbox linemax

   for i=0 to linemax
     chain = myarray(i)
     if instr(chain,input) > 0 then
       myarray(i) = ""
     end if    
   next
   mychaine = ""
   for i=0 to linemax
     if myarray(i) <> "" then mychaine = mychaine + myarray(i)+chr(13)+chr(10)
   next    
   obj2.text(mychaine) 
   logaddline("toutes les lignes contenant:[" +input+ "] ont t supprimes")
 end sub

'==============================================' 
'copy/paste de toutes les lignes contenant un text dans le clipboad
'==============================================' 
 sub copy_line
   dim input2
 ''logClear
 
   set obj1 = NewEditor()           'new editor object
   obj1.assignActiveEditor         'assign PSPad window active to obj1
 
   Input2 = InputBox("copy dans le clipboard de toutes les lignes contenant le texte donn")  
   mychaine = obj1.text
   mychaine = replace(mychaine,chr(10),"")
   myarray = split(mychaine,chr(13))
   linemax = ubound(myarray)
 ' msgbox linemax
   chain2 = ""
   for i=0 to linemax
     chain = myarray(i)
     if instr(chain,input2) > 0 then
       chain2 = chain2 + myarray(i) +chr(13)+chr(10)
     end if    
   next
   ClipBoard(chain2)
 end sub
 
'==============================================' 
' ClipBoard(input)
'=============================================='  
  Function ClipBoard(input)
    If IsNull(input) Then
      ClipBoard = CreateObject("HTMLFile").parentWindow.clipboardData.getData("Text")
      If IsNull(ClipBoard) Then ClipBoard = ""
    Elseif input ="" then
      Call CreateObject("htmlfile").ParentWindow.clipboardData.ClearData("text")
    else  
      Call CreateObject("htmlfile").ParentWindow.ClipboardData.setData("text",input)
    End If
  End Function
 'TO CLEAR
 'ClipBoard("")
 'TO SET
 'ClipBoard("Hello World!")
 'TO GET
 'Result = ClipBoard(Null)

'==============================================' 
'GetFileNameDlg
'=============================================='  
 Function GetFileNameDlg() 
GetFileNameDlg=CreateObject("WScript.Shell").Exec("mshta.exe ""about:<input type=file id=f><script language=""VBScript"">f.click():CreateObject(""Scripting.FileSystemObject"").GetStandardStream(1).WriteLine(f.value):close()</script>""").StdOut.ReadAll 
End Function 
'sample test
'MsgBox GetFileNameDlg()
'
Function GetFileDlg(sIniDir,sFilter,sTitle)
	GetFileDlg=CreateObject("WScript.Shell").Exec("mshta.exe ""about:<object id=d classid=clsid:3050f4e1-98b5-11cf-bb82-00aa00bdce0b></object><script>moveTo(0,-9999);function window.onload(){var p=/[^\0]*/;new ActiveXObject('Scripting.FileSystemObject').GetStandardStream(1).Write(p.exec(d.object.openfiledlg('" & sIniDir & "',null,'" & sFilter & "','" & sTitle & "')));close();}</script><hta:application showintaskbar=no />""").StdOut.ReadAll
End Function
' sample test
'sIniDir = "C:\Windows\Fonts\*"
'sFilter = "All files (*.*)|*.*|Microsoft Word (*.doc;*.docx)|*.doc;*.docx|Adobe pdf (*.pdf)|*.pdf|"
'sTitle = "GetFileDlg by omen999 2014 - omen999.developpez.com"
 
' (sIniDir + sFilter + sTitle) size doesn't exceed 191 chars (227 for GetFileDlgBar)
' MsgBox Len(Replace(sIniDir,"\","\\")) + Len(sFilter) + Len(sTitle)
' sIniDir must be conformed to the javascript syntax
'rep = GetFileDlg(Replace(sIniDir,"\","\\"),sFilter,sTitle)
'MsgBox rep & vbcrlf & Len(rep)

Function GetFileDlgEx(sIniDir,sFilter,sTitle) 
  Set oDlg = CreateObject("WScript.Shell").Exec("mshta.exe ""about:<object id=d classid=clsid:3050f4e1-98b5-11cf-bb82-00aa00bdce0b></object><script>moveTo(0,-9999);eval(new ActiveXObject('Scripting.FileSystemObject').GetStandardStream(0).Read("&Len(sIniDir)+Len(sFilter)+Len(sTitle)+41&"));function window.onload(){var p=/[^\0]*/;new ActiveXObject('Scripting.FileSystemObject').GetStandardStream(1).Write(p.exec(d.object.openfiledlg(iniDir,null,filter,title)));close();}</script><hta:application showintaskbar=no />""") 
  oDlg.StdIn.Write "var iniDir='" & sIniDir & "';var filter='" & sFilter & "';var title='" & sTitle & "';" 
  GetFileDlgEx = oDlg.StdOut.ReadAll 
End Function
 
'==============================================' 
'edition du scrip
'==============================================' 
  sub openScript
   set obj1 = newEditor()
   obj1.openFile(moduleFileName("B4R_library") )
 end sub
 
'==============================================' 
'init
'==============================================' 
' name "Init" is required, its called automatically during initialization to create menu items
sub Init
  addMenuItem "0-clean Arduino.h file"               ,"B4R"   , "clean"
  addMenuItem "1-create new cpp file"                ,"B4R"   , "cpp_create"
  addMenuItem "2-create new h file"                  ,"B4R"   , "h_create"  
  addMenuItem "3-create new xml file"                ,"B4R"   , "xml_create"    
  addMenuItem "4 --------------------"               ,"B4R"   , "rien"   
  addMenuItem "5-Clean comments //"                  ,"B4R"   , "clean_comments" 
  addMenuItem "6-Clean all comments //"              ,"B4R"   , "clean_header"   
  addMenuItem "View script"                          ,"B4R"   , "openScript"     
end sub 

'---------------------------'
'summary of callback inputs
'---------------------------'
'typedef included
'	SubVoidArray				typedef void (*SubVoidArray)(Array* barray) ;
'	SubVoidBool				typedef void (*SubVoidBool)(bool b) ;
'	SubVoidByte				typedef void (*SubVoidByte)(Byte b) ;
'	SubVoidVoid				typedef void (*SubVoidVoid) (void);
'	SubByteVoidP				typedef void (*SubByteVoidP)(Byte, void*)
'	SubVoidVoidP				typedef void (*SubVoidVoidP)(void*);
'typedef to add
'	SubVoidStringByteArray			typedef void (*SubVoidStringByteArray)(B4RString* str, Array* barray) ;
'	SubByteArray				typedef void (*SubByteArray)(Array* barray) ; 
'	SubByteArrayInt				typedef void (*SubByteArrayInt)(Array* barray, int* id, bool* ext) ; 
'	SubVoidStringArray			typedef void (*SubVoidStringArray)(B4RString* func, Array* barray) ;
''
'subname
'		MessageArrived
'		MessageArrivedSub
'		DisconnectedSub
'		NewMessageSub
'       etc...